""" Python Character Mapping Codec cp1047 generated from 'encoding\CP1047.TXT' with gencodec.py.

"""#"

import codecs

### Codec APIs

class Codec(codecs.Codec):

    def encode(self,input,errors='strict'):
        return codecs.charmap_encode(input,errors,encoding_table)

    def decode(self,input,errors='strict'):
        return codecs.charmap_decode(input,errors,decoding_table)

class IncrementalEncoder(codecs.IncrementalEncoder):
    def encode(self, input, final=False):
        return codecs.charmap_encode(input,self.errors,encoding_table)[0]

class IncrementalDecoder(codecs.IncrementalDecoder):
    def decode(self, input, final=False):
        return codecs.charmap_decode(input,self.errors,decoding_table)[0]

class StreamWriter(Codec,codecs.StreamWriter):
    pass

class StreamReader(Codec,codecs.StreamReader):
    pass

### encodings module API

def getregentry():
    return codecs.CodecInfo(
        name='cp1047',
        encode=Codec().encode,
        decode=Codec().decode,
        incrementalencoder=IncrementalEncoder,
        incrementaldecoder=IncrementalDecoder,
        streamreader=StreamReader,
        streamwriter=StreamWriter,
    )


### Decoding Table

decoding_table = (
    u'\x00'     #  0x00 -> NULL                                                   0x00: 0x00,
    u'\x01'     #  0x01 -> START OF HEADING                                       0x01: 0x01,
    u'\x02'     #  0x02 -> START OF TEXT                                          0x02: 0x02,
    u'\x03'     #  0x03 -> END OF TEXT                                            0x03: 0x03,
    u'\x9c'     #  0x04 -> CONTROL                                                0x04: 0x9c,
    u'\t'       #  0x05 -> HORIZONTAL TABULATION                                  0x05: 0x09,
    u'\x86'     #  0x06 -> CONTROL                                                0x06: 0x86,
    u'\x7f'     #  0x07 -> DELETE                                                 0x07: 0x7f,
    u'\x97'     #  0x08 -> CONTROL                                                0x08: 0x97,
    u'\x8d'     #  0x09 -> CONTROL                                                0x09: 0x8d,
    u'\x8e'     #  0x0A -> CONTROL                                                0x0a: 0x8e,
    u'\x0b'     #  0x0B -> VERTICAL TABULATION                                    0x0b: 0x0b,
    u'\x0c'     #  0x0C -> FORM FEED                                              0x0c: 0x0c,
    u'\r'       #  0x0D -> CARRIAGE RETURN                                        0x0d: 0x0d,
    u'\x0e'     #  0x0E -> SHIFT OUT                                              0x0e: 0x0e,
    u'\x0f'     #  0x0F -> SHIFT IN                                               0x0f: 0x0f,
    u'\x10'     #  0x10 -> DATA LINK ESCAPE                                       0x10: 0x10,
    u'\x11'     #  0x11 -> DEVICE CONTROL ONE                                     0x11: 0x11,
    u'\x12'     #  0x12 -> DEVICE CONTROL TWO                                     0x12: 0x12,
    u'\x13'     #  0x13 -> DEVICE CONTROL THREE                                   0x13: 0x13,
    u'\x9d'     #  0x14 -> CONTROL                                                0x14: 0x9d,
    u'\n'       #  0x15 -> CONTROL                                                0x15: 0x0a, # Line Feed / x'85' in IBM-037
    u'\x08'     #  0x16 -> BACKSPACE                                              0x16: 0x08,
    u'\x87'     #  0x17 -> CONTROL                                                0x17: 0x87,
    u'\x18'     #  0x18 -> CANCEL                                                 0x18: 0x18,
    u'\x19'     #  0x19 -> END OF MEDIUM                                          0x19: 0x19,
    u'\x92'     #  0x1A -> CONTROL                                                0x1a: 0x92,
    u'\x8f'     #  0x1B -> CONTROL                                                0x1b: 0x8f,
    u'\x1c'     #  0x1C -> FILE SEPARATOR                                         0x1c: 0x1c,
    u'\x1d'     #  0x1D -> GROUP SEPARATOR                                        0x1d: 0x1d,
    u'\x1e'     #  0x1E -> RECORD SEPARATOR                                       0x1e: 0x1e,
    u'\x1f'     #  0x1F -> UNIT SEPARATOR                                         0x1f: 0x1f,
    u'\x80'     #  0x20 -> CONTROL                                                0x20: 0x80,
    u'\x81'     #  0x21 -> CONTROL                                                0x21: 0x81,
    u'\x82'     #  0x22 -> CONTROL                                                0x22: 0x82,
    u'\x83'     #  0x23 -> CONTROL                                                0x23: 0x83,
    u'\x84'     #  0x24 -> CONTROL                                                0x24: 0x84,
    u'\x85'     #  0x25 -> LINE FEED                                              0x25: 0x85, # Next Line / x'0a' in IBM-037
    u'\x17'     #  0x26 -> END OF TRANSMISSION BLOCK                              0x26: 0x17,
    u'\x1b'     #  0x27 -> ESCAPE                                                 0x27: 0x1b,
    u'\x88'     #  0x28 -> CONTROL                                                0x28: 0x88,
    u'\x89'     #  0x29 -> CONTROL                                                0x29: 0x89,
    u'\x8a'     #  0x2A -> CONTROL                                                0x2a: 0x8a,
    u'\x8b'     #  0x2B -> CONTROL                                                0x2b: 0x8b,
    u'\x8c'     #  0x2C -> CONTROL                                                0x2c: 0x8c,
    u'\x05'     #  0x2D -> ENQUIRY                                                0x2d: 0x05,
    u'\x06'     #  0x2E -> ACKNOWLEDGE                                            0x2e: 0x06,
    u'\x07'     #  0x2F -> BELL                                                   0x2f: 0x07,
    u'\x90'     #  0x30 -> CONTROL                                                0x30: 0x90,
    u'\x91'     #  0x31 -> CONTROL                                                0x31: 0x91,
    u'\x16'     #  0x32 -> SYNCHRONOUS IDLE                                       0x32: 0x16,
    u'\x93'     #  0x33 -> CONTROL                                                0x33: 0x93,
    u'\x94'     #  0x34 -> CONTROL                                                0x34: 0x94,
    u'\x95'     #  0x35 -> CONTROL                                                0x35: 0x95,
    u'\x96'     #  0x36 -> CONTROL                                                0x36: 0x96,
    u'\x04'     #  0x37 -> END OF TRANSMISSION                                    0x37: 0x04,
    u'\x98'     #  0x38 -> CONTROL                                                0x38: 0x98,
    u'\x99'     #  0x39 -> CONTROL                                                0x39: 0x99,
    u'\x9a'     #  0x3A -> CONTROL                                                0x3a: 0x9a,
    u'\x9b'     #  0x3B -> CONTROL                                                0x3b: 0x9b,
    u'\x14'     #  0x3C -> DEVICE CONTROL FOUR                                    0x3c: 0x14,
    u'\x15'     #  0x3D -> NEGATIVE ACKNOWLEDGE                                   0x3d: 0x15,
    u'\x9e'     #  0x3E -> CONTROL                                                0x3e: 0x9e,
    u'\x1a'     #  0x3F -> SUBSTITUTE                                             0x3f: 0x1a,
    u' '        #  0x40 -> SPACE                                                  0x40: 0x20,
    u'\xa0'     #  0x41 -> NO-BREAK SPACE                                         0x41: 0xa0,
    u'\xe2'     #  0x42 -> LATIN SMALL LETTER A WITH CIRCUMFLEX                   0x42: 0xe2,
    u'\xe4'     #  0x43 -> LATIN SMALL LETTER A WITH DIAERESIS                    0x43: 0xe4,
    u'\xe0'     #  0x44 -> LATIN SMALL LETTER A WITH GRAVE                        0x44: 0xe0,
    u'\xe1'     #  0x45 -> LATIN SMALL LETTER A WITH ACUTE                        0x45: 0xe1,
    u'\xe3'     #  0x46 -> LATIN SMALL LETTER A WITH TILDE                        0x46: 0xe3,
    u'\xe5'     #  0x47 -> LATIN SMALL LETTER A WITH RING ABOVE                   0x47: 0xe5,
    u'\xe7'     #  0x48 -> LATIN SMALL LETTER C WITH CEDILLA                      0x48: 0xe7,
    u'\xf1'     #  0x49 -> LATIN SMALL LETTER N WITH TILDE                        0x49: 0xf1,
    u'\xa2'     #  0x4A -> CENT SIGN                                              0x4a: 0xa2,
    u'.'        #  0x4B -> FULL STOP                                              0x4b: 0x2e,
    u'<'        #  0x4C -> LESS-THAN SIGN                                         0x4c: 0x3c,
    u'('        #  0x4D -> LEFT PARENTHESIS                                       0x4d: 0x28,
    u'+'        #  0x4E -> PLUS SIGN                                              0x4e: 0x2b,
    u'|'        #  0x4F -> VERTICAL LINE                                          0x4f: 0x7c,
    u'&'        #  0x50 -> AMPERSAND                                              0x50: 0x26,
    u'\xe9'     #  0x51 -> LATIN SMALL LETTER E WITH ACUTE                        0x51: 0xe9,
    u'\xea'     #  0x52 -> LATIN SMALL LETTER E WITH CIRCUMFLEX                   0x52: 0xea,
    u'\xeb'     #  0x53 -> LATIN SMALL LETTER E WITH DIAERESIS                    0x53: 0xeb,
    u'\xe8'     #  0x54 -> LATIN SMALL LETTER E WITH GRAVE                        0x54: 0xe8,
    u'\xed'     #  0x55 -> LATIN SMALL LETTER I WITH ACUTE                        0x55: 0xed,
    u'\xee'     #  0x56 -> LATIN SMALL LETTER I WITH CIRCUMFLEX                   0x56: 0xee,
    u'\xef'     #  0x57 -> LATIN SMALL LETTER I WITH DIAERESIS                    0x57: 0xef,
    u'\xec'     #  0x58 -> LATIN SMALL LETTER I WITH GRAVE                        0x58: 0xec,
    u'\xdf'     #  0x59 -> LATIN SMALL LETTER SHARP S (GERMAN)                    0x59: 0xdf,
    u'!'        #  0x5A -> EXCLAMATION MARK                                       0x5a: 0x21,
    u'$'        #  0x5B -> DOLLAR SIGN                                            0x5b: 0x24,
    u'*'        #  0x5C -> ASTERISK                                               0x5c: 0x2a,
    u')'        #  0x5D -> RIGHT PARENTHESIS                                      0x5d: 0x29,
    u';'        #  0x5E -> SEMICOLON                                              0x5e: 0x3b,
    u'^'        #  0x5F -> NOT SIGN                                               0x5f: 0x5e, # Circumflex Accent (Not sign) / x'ac' in IBM-037
    u'-'        #  0x60 -> HYPHEN-MINUS                                           0x60: 0x2d,
    u'/'        #  0x61 -> SOLIDUS                                                0x61: 0x2f,
    u'\xc2'     #  0x62 -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX                 0x62: 0xc2,
    u'\xc4'     #  0x63 -> LATIN CAPITAL LETTER A WITH DIAERESIS                  0x63: 0xc4,
    u'\xc0'     #  0x64 -> LATIN CAPITAL LETTER A WITH GRAVE                      0x64: 0xc0,
    u'\xc1'     #  0x65 -> LATIN CAPITAL LETTER A WITH ACUTE                      0x65: 0xc1,
    u'\xc3'     #  0x66 -> LATIN CAPITAL LETTER A WITH TILDE                      0x66: 0xc3,
    u'\xc5'     #  0x67 -> LATIN CAPITAL LETTER A WITH RING ABOVE                 0x67: 0xc5,
    u'\xc7'     #  0x68 -> LATIN CAPITAL LETTER C WITH CEDILLA                    0x68: 0xc7,
    u'\xd1'     #  0x69 -> LATIN CAPITAL LETTER N WITH TILDE                      0x69: 0xd1,
    u'\xa6'     #  0x6A -> BROKEN BAR                                             0x6a: 0xa6,
    u','        #  0x6B -> COMMA                                                  0x6b: 0x2c,
    u'%'        #  0x6C -> PERCENT SIGN                                           0x6c: 0x25,
    u'_'        #  0x6D -> LOW LINE                                               0x6d: 0x5f,
    u'>'        #  0x6E -> GREATER-THAN SIGN                                      0x6e: 0x3e,
    u'?'        #  0x6F -> QUESTION MARK                                          0x6f: 0x3f,
    u'\xf8'     #  0x70 -> LATIN SMALL LETTER O WITH STROKE                       0x70: 0xf8,
    u'\xc9'     #  0x71 -> LATIN CAPITAL LETTER E WITH ACUTE                      0x71: 0xc9,
    u'\xca'     #  0x72 -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX                 0x72: 0xca,
    u'\xcb'     #  0x73 -> LATIN CAPITAL LETTER E WITH DIAERESIS                  0x73: 0xcb,
    u'\xc8'     #  0x74 -> LATIN CAPITAL LETTER E WITH GRAVE                      0x74: 0xc8,
    u'\xcd'     #  0x75 -> LATIN CAPITAL LETTER I WITH ACUTE                      0x75: 0xcd,
    u'\xce'     #  0x76 -> LATIN CAPITAL LETTER I WITH CIRCUMFLEX                 0x76: 0xce,
    u'\xcf'     #  0x77 -> LATIN CAPITAL LETTER I WITH DIAERESIS                  0x77: 0xcf,
    u'\xcc'     #  0x78 -> LATIN CAPITAL LETTER I WITH GRAVE                      0x78: 0xcc,
    u'`'        #  0x79 -> GRAVE ACCENT                                           0x79: 0x60,
    u':'        #  0x7A -> COLON                                                  0x7a: 0x3a,
    u'#'        #  0x7B -> NUMBER SIGN                                            0x7b: 0x23,
    u'@'        #  0x7C -> COMMERCIAL AT                                          0x7c: 0x40,
    u"'"        #  0x7D -> APOSTROPHE                                             0x7d: 0x27,
    u'='        #  0x7E -> EQUALS SIGN                                            0x7e: 0x3d,
    u'"'        #  0x7F -> QUOTATION MARK                                         0x7f: 0x22,
    u'\xd8'     #  0x80 -> LATIN CAPITAL LETTER O WITH STROKE                     0x80: 0xd8,
    u'a'        #  0x81 -> LATIN SMALL LETTER A                                   0x81: 0x61,
    u'b'        #  0x82 -> LATIN SMALL LETTER B                                   0x82: 0x62,
    u'c'        #  0x83 -> LATIN SMALL LETTER C                                   0x83: 0x63,
    u'd'        #  0x84 -> LATIN SMALL LETTER D                                   0x84: 0x64,
    u'e'        #  0x85 -> LATIN SMALL LETTER E                                   0x85: 0x65,
    u'f'        #  0x86 -> LATIN SMALL LETTER F                                   0x86: 0x66,
    u'g'        #  0x87 -> LATIN SMALL LETTER G                                   0x87: 0x67,
    u'h'        #  0x88 -> LATIN SMALL LETTER H                                   0x88: 0x68,
    u'i'        #  0x89 -> LATIN SMALL LETTER I                                   0x89: 0x69,
    u'\xab'     #  0x8A -> LEFT-POINTING DOUBLE ANGLE QUOTATION MARK              0x8a: 0xab,
    u'\xbb'     #  0x8B -> RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK             0x8b: 0xbb,
    u'\xf0'     #  0x8C -> LATIN SMALL LETTER ETH (ICELANDIC)                     0x8c: 0xf0,
    u'\xfd'     #  0x8D -> LATIN SMALL LETTER Y WITH ACUTE                        0x8d: 0xfd,
    u'\xfe'     #  0x8E -> LATIN SMALL LETTER THORN (ICELANDIC)                   0x8e: 0xfe,
    u'\xb1'     #  0x8F -> PLUS-MINUS SIGN                                        0x8f: 0xb1,
    u'\xb0'     #  0x90 -> DEGREE SIGN                                            0x90: 0xb0,
    u'j'        #  0x91 -> LATIN SMALL LETTER J                                   0x91: 0x6a,
    u'k'        #  0x92 -> LATIN SMALL LETTER K                                   0x92: 0x6b,
    u'l'        #  0x93 -> LATIN SMALL LETTER L                                   0x93: 0x6c,
    u'm'        #  0x94 -> LATIN SMALL LETTER M                                   0x94: 0x6d,
    u'n'        #  0x95 -> LATIN SMALL LETTER N                                   0x95: 0x6e,
    u'o'        #  0x96 -> LATIN SMALL LETTER O                                   0x96: 0x6f,
    u'p'        #  0x97 -> LATIN SMALL LETTER P                                   0x97: 0x70,
    u'q'        #  0x98 -> LATIN SMALL LETTER Q                                   0x98: 0x71,
    u'r'        #  0x99 -> LATIN SMALL LETTER R                                   0x99: 0x72,
    u'\xaa'     #  0x9A -> FEMININE ORDINAL INDICATOR                             0x9a: 0xaa,
    u'\xba'     #  0x9B -> MASCULINE ORDINAL INDICATOR                            0x9b: 0xba,
    u'\xe6'     #  0x9C -> LATIN SMALL LIGATURE AE                                0x9c: 0xe6,
    u'\xb8'     #  0x9D -> CEDILLA                                                0x9d: 0xb8,
    u'\xc6'     #  0x9E -> LATIN CAPITAL LIGATURE AE                              0x9e: 0xc6,
    u'\xa4'     #  0x9F -> CURRENCY SIGN                                          0x9f: 0xa4,
    u'\xb5'     #  0xA0 -> MICRO SIGN                                             0xa0: 0xb5,
    u'~'        #  0xA1 -> TILDE                                                  0xa1: 0x7e,
    u's'        #  0xA2 -> LATIN SMALL LETTER S                                   0xa2: 0x73,
    u't'        #  0xA3 -> LATIN SMALL LETTER T                                   0xa3: 0x74,
    u'u'        #  0xA4 -> LATIN SMALL LETTER U                                   0xa4: 0x75,
    u'v'        #  0xA5 -> LATIN SMALL LETTER V                                   0xa5: 0x76,
    u'w'        #  0xA6 -> LATIN SMALL LETTER W                                   0xa6: 0x77,
    u'x'        #  0xA7 -> LATIN SMALL LETTER X                                   0xa7: 0x78,
    u'y'        #  0xA8 -> LATIN SMALL LETTER Y                                   0xa8: 0x79,
    u'z'        #  0xA9 -> LATIN SMALL LETTER Z                                   0xa9: 0x7a,
    u'\xa1'     #  0xAA -> INVERTED EXCLAMATION MARK                              0xaa: 0xa1,
    u'\xbf'     #  0xAB -> INVERTED QUESTION MARK                                 0xab: 0xbf,
    u'\xd0'     #  0xAC -> LATIN CAPITAL LETTER ETH (ICELANDIC)                   0xac: 0xd0,
    u'['        #  0xAD -> LATIN CAPITAL LETTER Y WITH ACUTE                      0xad: 0x5b, # Left Square Bracket / x'dd' in IBM-037
    u'\xde'     #  0xAE -> LATIN CAPITAL LETTER THORN (ICELANDIC)                 0xae: 0xde,
    u'\xae'     #  0xAF -> REGISTERED SIGN                                        0xaf: 0xae,
    u'\xac'     #  0xB0 -> CIRCUMFLEX ACCENT                                      0xb0: 0xac, # Not sign / x'5e' in IBM-037
    u'\xa3'     #  0xB1 -> POUND SIGN                                             0xb1: 0xa3,
    u'\xa5'     #  0xB2 -> YEN SIGN                                               0xb2: 0xa5,
    u'\xb7'     #  0xB3 -> MIDDLE DOT                                             0xb3: 0xb7,
    u'\xa9'     #  0xB4 -> COPYRIGHT SIGN                                         0xb4: 0xa9,
    u'\xa7'     #  0xB5 -> SECTION SIGN                                           0xb5: 0xa7,
    u'\xb6'     #  0xB6 -> PILCROW SIGN                                           0xb6: 0xb6,
    u'\xbc'     #  0xB7 -> VULGAR FRACTION ONE QUARTER                            0xb7: 0xbc,
    u'\xbd'     #  0xB8 -> VULGAR FRACTION ONE HALF                               0xb8: 0xbd,
    u'\xbe'     #  0xB9 -> VULGAR FRACTION THREE QUARTERS                         0xb9: 0xbe,
    u'\xdd'     #  0xBA -> LEFT SQUARE BRACKET                                    0xba: 0xdd, # Capital Y with Acute / x'5b' in IBM-037
    u'\xa8'     #  0xBB -> RIGHT SQUARE BRACKET                                   0xbb: 0xa8, # Diaeresis / x'5d' in IBM-037
    u'\xaf'     #  0xBC -> MACRON                                                 0xbc: 0xaf,
    u']'        #  0xBD -> DIAERESIS                                              0xbd: 0x5d, # Right Square Bracket / x'a8' in IBM-037
    u'\xb4'     #  0xBE -> ACUTE ACCENT                                           0xbe: 0xb4,
    u'\xd7'     #  0xBF -> MULTIPLICATION SIGN                                    0xbf: 0xd7,
    u'{'        #  0xC0 -> LEFT CURLY BRACKET                                     0xc0: 0x7b,
    u'A'        #  0xC1 -> LATIN CAPITAL LETTER A                                 0xc1: 0x41,
    u'B'        #  0xC2 -> LATIN CAPITAL LETTER B                                 0xc2: 0x42,
    u'C'        #  0xC3 -> LATIN CAPITAL LETTER C                                 0xc3: 0x43,
    u'D'        #  0xC4 -> LATIN CAPITAL LETTER D                                 0xc4: 0x44,
    u'E'        #  0xC5 -> LATIN CAPITAL LETTER E                                 0xc5: 0x45,
    u'F'        #  0xC6 -> LATIN CAPITAL LETTER F                                 0xc6: 0x46,
    u'G'        #  0xC7 -> LATIN CAPITAL LETTER G                                 0xc7: 0x47,
    u'H'        #  0xC8 -> LATIN CAPITAL LETTER H                                 0xc8: 0x48,
    u'I'        #  0xC9 -> LATIN CAPITAL LETTER I                                 0xc9: 0x49,
    u'\xad'     #  0xCA -> SOFT HYPHEN                                            0xca: 0xad,
    u'\xf4'     #  0xCB -> LATIN SMALL LETTER O WITH CIRCUMFLEX                   0xcb: 0xf4,
    u'\xf6'     #  0xCC -> LATIN SMALL LETTER O WITH DIAERESIS                    0xcc: 0xf6,
    u'\xf2'     #  0xCD -> LATIN SMALL LETTER O WITH GRAVE                        0xcd: 0xf2,
    u'\xf3'     #  0xCE -> LATIN SMALL LETTER O WITH ACUTE                        0xce: 0xf3,
    u'\xf5'     #  0xCF -> LATIN SMALL LETTER O WITH TILDE                        0xcf: 0xf5,
    u'}'        #  0xD0 -> RIGHT CURLY BRACKET                                    0xd0: 0x7d,
    u'J'        #  0xD1 -> LATIN CAPITAL LETTER J                                 0xd1: 0x4a,
    u'K'        #  0xD2 -> LATIN CAPITAL LETTER K                                 0xd2: 0x4b,
    u'L'        #  0xD3 -> LATIN CAPITAL LETTER L                                 0xd3: 0x4c,
    u'M'        #  0xD4 -> LATIN CAPITAL LETTER M                                 0xd4: 0x4d,
    u'N'        #  0xD5 -> LATIN CAPITAL LETTER N                                 0xd5: 0x4e,
    u'O'        #  0xD6 -> LATIN CAPITAL LETTER O                                 0xd6: 0x4f,
    u'P'        #  0xD7 -> LATIN CAPITAL LETTER P                                 0xd7: 0x50,
    u'Q'        #  0xD8 -> LATIN CAPITAL LETTER Q                                 0xd8: 0x51,
    u'R'        #  0xD9 -> LATIN CAPITAL LETTER R                                 0xd9: 0x52,
    u'\xb9'     #  0xDA -> SUPERSCRIPT ONE                                        0xda: 0xb9,
    u'\xfb'     #  0xDB -> LATIN SMALL LETTER U WITH CIRCUMFLEX                   0xdb: 0xfb,
    u'\xfc'     #  0xDC -> LATIN SMALL LETTER U WITH DIAERESIS                    0xdc: 0xfc,
    u'\xf9'     #  0xDD -> LATIN SMALL LETTER U WITH GRAVE                        0xdd: 0xf9,
    u'\xfa'     #  0xDE -> LATIN SMALL LETTER U WITH ACUTE                        0xde: 0xfa,
    u'\xff'     #  0xDF -> LATIN SMALL LETTER Y WITH DIAERESIS                    0xdf: 0xff,
    u'\\'       #  0xE0 -> REVERSE SOLIDUS                                        0xe0: 0x5c,
    u'\xf7'     #  0xE1 -> DIVISION SIGN                                          0xe1: 0xf7,
    u'S'        #  0xE2 -> LATIN CAPITAL LETTER S                                 0xe2: 0x53,
    u'T'        #  0xE3 -> LATIN CAPITAL LETTER T                                 0xe3: 0x54,
    u'U'        #  0xE4 -> LATIN CAPITAL LETTER U                                 0xe4: 0x55,
    u'V'        #  0xE5 -> LATIN CAPITAL LETTER V                                 0xe5: 0x56,
    u'W'        #  0xE6 -> LATIN CAPITAL LETTER W                                 0xe6: 0x57,
    u'X'        #  0xE7 -> LATIN CAPITAL LETTER X                                 0xe7: 0x58,
    u'Y'        #  0xE8 -> LATIN CAPITAL LETTER Y                                 0xe8: 0x59,
    u'Z'        #  0xE9 -> LATIN CAPITAL LETTER Z                                 0xe9: 0x5a,
    u'\xb2'     #  0xEA -> SUPERSCRIPT TWO                                        0xea: 0xb2,
    u'\xd4'     #  0xEB -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX                 0xeb: 0xd4,
    u'\xd6'     #  0xEC -> LATIN CAPITAL LETTER O WITH DIAERESIS                  0xec: 0xd6,
    u'\xd2'     #  0xED -> LATIN CAPITAL LETTER O WITH GRAVE                      0xed: 0xd2,
    u'\xd3'     #  0xEE -> LATIN CAPITAL LETTER O WITH ACUTE                      0xee: 0xd3,
    u'\xd5'     #  0xEF -> LATIN CAPITAL LETTER O WITH TILDE                      0xef: 0xd5,
    u'0'        #  0xF0 -> DIGIT ZERO                                             0xf0: 0x30,
    u'1'        #  0xF1 -> DIGIT ONE                                              0xf1: 0x31,
    u'2'        #  0xF2 -> DIGIT TWO                                              0xf2: 0x32,
    u'3'        #  0xF3 -> DIGIT THREE                                            0xf3: 0x33,
    u'4'        #  0xF4 -> DIGIT FOUR                                             0xf4: 0x34,
    u'5'        #  0xF5 -> DIGIT FIVE                                             0xf5: 0x35,
    u'6'        #  0xF6 -> DIGIT SIX                                              0xf6: 0x36,
    u'7'        #  0xF7 -> DIGIT SEVEN                                            0xf7: 0x37,
    u'8'        #  0xF8 -> DIGIT EIGHT                                            0xf8: 0x38,
    u'9'        #  0xF9 -> DIGIT NINE                                             0xf9: 0x39,
    u'\xb3'     #  0xFA -> SUPERSCRIPT THREE                                      0xfa: 0xb3,
    u'\xdb'     #  0xFB -> LATIN CAPITAL LETTER U WITH CIRCUMFLEX                 0xfb: 0xdb,
    u'\xdc'     #  0xFC -> LATIN CAPITAL LETTER U WITH DIAERESIS                  0xfc: 0xdc,
    u'\xd9'     #  0xFD -> LATIN CAPITAL LETTER U WITH GRAVE                      0xfd: 0xd9,
    u'\xda'     #  0xFE -> LATIN CAPITAL LETTER U WITH ACUTE                      0xfe: 0xda,
    u'\x9f'     #  0xFF -> CONTROL                                                0xff: 0x9f,
)

### Encoding table
encoding_table=codecs.charmap_build(decoding_table)
