#####################################################################         
# Licensed Materials - Property of IBM
#  
# 5724-L62  
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.     
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
##################################################################### 
# Site customization for ITCAM 7.2 installer scripts
##################################################################### 

import sys, codecs
from java.lang.System import getProperties


# Get the system properties

_propname8859 = "python.disable.8859.alias"
_propnamedefault = "python.default.encoding"

_props = getProperties()


# Provide an aliases for 8859_1 on HP-UX

def alias8859_1(nm):

    aliases = {"8859_1":"iso-8859-1",
               "8859_2":"iso-8859-2",
               "8859_3":"iso-8859-3",
               "8859_4":"iso-8859-4",
               "8859_5":"iso-8859-5",
               "8859_6":"iso-8859-6",
               "8859_7":"iso-8859-7",
               "8859_8":"iso-8859-8",
               "8859_9":"iso-8859-9",
               "8859_10":"iso-8859-10",
               "8859_11":"iso-8859-11",
               "8859_12":"iso-8859-12",
               "8859_13":"iso-8859-13",
               "8859_14":"iso-8859-14",
               "8859_15":"iso-8859-15"}
               
    if nm in aliases:
        return codecs.lookup(aliases[nm])

        
if _propname8859 not in _props or _props[_propname8859] != "true":
    codecs.register(alias8859_1)


# Allow override of default encoding

if _propnamedefault in _props:
    defaultencoding = _props[_propnamedefault]
    if defaultencoding != None and defaultencoding != "":
        sys.setdefaultencoding(defaultencoding)
