@echo off
rem ****************************************************** {COPYRIGHT-TOP} ***
rem Licensed Materials - Property of IBM
rem 5724-M07, 5698-A77
rem
rem (C) Copyright IBM Corp. 2012 All Rights Reserved.
rem
rem US Government Users Restricted Rights - Use, duplication, or
rem disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem ****************************************************** {COPYRIGHT-END} ***

setlocal
set LDIR="%~dp0"
cd %LDIR%

set JARFILE=kd4dcagent.jar
set JARFILE61=kd4was61dcagent.jar
set WASCOREJARFILE=com.ibm.management.soa.agent_7.2.0.jar
set WSCLIENT_JARFILE=com.ibm.management.soa.wsclient_7.2.0.jar
set JAXRPC_CLIENT_JARFILE=com.ibm.management.soa.jaxrpc.client_7.2.0.jar
                   
if "%2"=="" GOTO syntaxError
  
:parseArgs
set IN_OR_OUT=%1
set KD4_WAS_HOME=%2

if exist %KD4_WAS_HOME%\properties\version goto foundWAS
if exist "%KD4_WAS_HOME%"\properties\version goto needWASQuotes
goto NoWASInstall

:needWASQuotes
REM WAS Home needs quotes around it to work, so add them
REM in order to allow the rest of the script to work
set KD4_WAS_TEMP=%KD4_WAS_HOME%
set KD4_WAS_HOME="%KD4_WAS_TEMP%"
                                         
:foundWAS                                         
if "%IN_OR_OUT%"=="-enable" GOTO copyJar
if "%IN_OR_OUT%"=="-disable" GOTO deleteJar    
GOTO syntaxError
        
:copyJar
if exist %KD4_WAS_HOME%\lib\ext\%JARFILE% goto oldSOADCFound
if exist %KD4_WAS_HOME%\lib\ext\%JARFILE61% goto oldSOADCFound
if exist %KD4_WAS_HOME%\lib\ext\%WASCOREJARFILE% goto oldSOADCFound

copy /y ..\soadc\lib\client\%WSCLIENT_JARFILE% %KD4_WAS_HOME%\plugins\
if not "%ERRORLEVEL%"=="0" goto copyfailed
copy /y ..\soadc\lib\client\%JAXRPC_CLIENT_JARFILE% %KD4_WAS_HOME%\lib\ext
if "%ERRORLEVEL%"=="0" goto runOsgiCfgInit
goto copyfailed

:runOsgiCfgInit
REM clean OSGi configuration in all of the profiles
call %KD4_WAS_HOME%\bin\osgiCfgInit.bat -all
set OSGI_RC=%ERRORLEVEL%
if "%OSGI_RC%"=="0" goto success
REM tolerate a WAS bug
if "%OSGI_RC%"=="1" goto success

REM Create a new message for failure in the osgiCommand
goto copyfailed

:deleteJar
del /f %KD4_WAS_HOME%\plugins\%WSCLIENT_JARFILE%
if exist %KD4_WAS_HOME%\plugins\%WSCLIENT_JARFILE% goto deletefailed
del /f %KD4_WAS_HOME%\lib\ext\%JAXRPC_CLIENT_JARFILE%
if exist %KD4_WAS_HOME%\lib\ext\%JAXRPC_CLIENT_JARFILE% goto deletefailed

REM clean OSGi configuration in all of the profiles
call %KD4_WAS_HOME%\bin\osgiCfgInit.bat -all
set OSGI_RC=%ERRORLEVEL%
if "%OSGI_RC%"=="0" goto success
REM tolerate a WAS bug
if "%OSGI_RC%"=="1" goto success

goto success

:syntaxError
echo Syntax Error.
echo "Usage: configSOAWASClientDC.bat -enable|-disable <WAS_HOME>"
set KD4_RC=100
goto end

:oldSOADCFound
echo SOA WebSphere Client DC is not enabled because an older version of SOA DC is found in %KD4_WAS_HOME%\lib\ext. 
set KD4_RC=103
goto end

:NoWASInstall
echo %KD4_WAS_HOME% is not the home directory of a WebSphere Application Server
set KD4_RC=120
goto end

:copyfailed
ehco Fail to copy the SOA Client DC jar files.
set KD4_RC=103
goto end

:deletefailed
echo Fail to remove the SOA Client DC jar files.
set KD4_RC=104
goto end

:success
set KD4_RC=0
goto end


:end
exit /B %KD4_RC%                            


