#!/bin/sh  
# ****************************************************** {COPYRIGHT-TOP} ***
# Licensed Materials - Property of IBM
# 5724-M07, 5698-A77, 5698-B16
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication, or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ****************************************************** {COPYRIGHT-END} ***

DIR=`dirname $0`
cd $DIR

JARFILE=kd4dcagent.jar
JARFILE61=kd4was61dcagent.jar
WASCOREJARFILE=com.ibm.management.soa.agent_7.2.0.jar
WSCLIENT_JARFILE=com.ibm.management.soa.wsclient_7.2.0.jar
JAXRPC_CLIENT_JARFILE=com.ibm.management.soa.jaxrpc.client_7.2.0.jar
NEWCP_RC=0
NEWRM_RC=0
                     
IN_OR_OUT=$1

if [ ! "$2" ] 
then
   echo "Syntax Error."
   echo "Usage: configSOAWASClientDC.sh -enable|-disable <WAS_HOME>"
   exit 100
fi

KD4_WAS_HOME=$2

if [ -d "$KD4_WAS_HOME/properties/version" ]
then
   if [ "$IN_OR_OUT" = "-enable" ]
   then
      if [ -f "$KD4_WAS_HOME/lib/ext/$JARFILE" ]
      then
	echo "SOA WebSphere Client DC is not enabled because an older version of SOA DC is found in $KD4_WAS_HOME/lib/ext."
        exit 103
      fi
      if [ -f "$KD4_WAS_HOME/lib/ext/$WASCOREJARFILE" ]
      then
	echo "SOA WebSphere Client DC is not enabled because an older version of SOA DC is found in $KD4_WAS_HOME/lib/ext."
        exit 103
      fi
      if [ -f "$KD4_WAS_HOME/lib/ext/$JARFILE61" ]
      then
        echo "SOA WebSphere Client DC is not enabled because an older version of SOA DC is found in $KD4_WAS_HOME/lib/ext."
        exit 103
      fi

      cp -f ../soadc/lib/client/$WSCLIENT_JARFILE "$KD4_WAS_HOME"/plugins
      NEWCP_RC=$?
      if [ "$NEWCP_RC" = "0" ]
      then
        cp -f ../soadc/lib/client/$JAXRPC_CLIENT_JARFILE "$KD4_WAS_HOME"/lib/ext
	NEWCP_RC=$?
	if [ "$NEWCP_RC" = "0" ]
	then
	    sh "$KD4_WAS_HOME"/bin/osgiCfgInit.sh -all
	    exit $?
	fi
      fi
      # 121 = unable to copy
      echo "Fail to copy the SOA Client DC jar files"
      exit 121
   fi
   
   if [ "$IN_OR_OUT" = "-disable" ]
   then
      rm -f "$KD4_WAS_HOME"/plugins/$WSCLIENT_JARFILE
      RM_RC=$?

      if [ "$RM_RC" = "0" ]
      then
	 rm -f "$KD4_WAS_HOME"/lib/ext/$JAXRPC_CLIENT_JARFILE
	 RM_RC=$?
	 if [ "$RM_RC" = "0" ]
	 then
	     sh "$KD4_WAS_HOME"/bin/osgiCfgInit.sh -all
	     exit $?
	 fi
      fi
      # 124 = unable to delete
      echo "Fail to remove the SOA WAS Client DC jar files"
      exit 124
   fi
else
   # 120=bad WAS home
   echo "$KD4_WAS_HOME is not the home directory of a WebSphere Application Server" 
   exit 120
fi
