@echo off

@REM #####################################################################         
@REM # Licensed Materials - Property of IBM
@REM #  
@REM # 5724-L62  
@REM #
@REM # (C) Copyright IBM Corp. 2012 All Rights Reserved.       
@REM #
@REM # US Government Users Restricted Rights - Use, duplication or
@REM # disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@REM # 
@REM ##################################################################### 

setlocal enableextensions enabledelayedexpansion

@REM Check ITCAM_CONFIGHOME environment variable

@REM If not defined, set it relative to this script
if not defined ITCAM_CONFIGHOME set ITCAM_CONFIGHOME=%~dp0..

@REM Remove quotes from ITCAM_CONFIGHOME
set dequote=###%ITCAM_CONFIGHOME%###
set dequote=%dequote:###"=%
set dequote=%dequote:"###=%
set dequote=%dequote:###=%
set ITCAM_CONFIGHOME=%dequote%

@REM Validate ITCAM_CONFIGHOME
if not exist "%ITCAM_CONFIGHOME%\bin\config.bat"   goto err_noConfigHome
if not exist "%ITCAM_CONFIGHOME%\bin\reconfig.bat" goto err_noConfigHome
if not exist "%ITCAM_CONFIGHOME%\bin\migrate.bat"  goto err_noConfigHome
if not exist "%ITCAM_CONFIGHOME%\bin\jython\jython.jar" goto err_noConfigHome
if not exist "%ITCAM_CONFIGHOME%\bin\lib\installbundle.jar" goto err_noConfigHome

@REM Locate Java Home in the path if JAVA_HOME is not defined
set temp_path=%PATH%
:findJavaHome
if not defined JAVA_HOME if defined temp_path (
  for /F "tokens=1,* delims=;" %%D in ("%temp_path%") do (
    if not "%%~D" == "" if exist "%%~D\java.exe" if "%%~nD" == "bin" set JAVA_HOME="%%~dpD"
    set temp_path=%%E
  )
  goto findJavaHome
)

@REM Remove quotes from JAVA_HOME
set dequote=###%JAVA_HOME%###
set dequote=%dequote:###"=%
set dequote=%dequote:"###=%
set dequote=%dequote:###=%
set JAVA_HOME=%dequote%

@REM Validate Java Home
if not exist "%JAVA_HOME%\bin\java.exe" if exist "%JAVA_HOME%\jre\bin\java.exe" set JAVA_HOME=%JAVA_HOME%\jre
set JAVA_EXE=%JAVA_HOME%\bin\java
if not exist "%JAVA_EXE%.exe" set JAVA_EXE=%JAVA_HOME%\jre\bin\java
if not exist "%JAVA_EXE%.exe" goto err_noJavaHome
@REM for %%F in ("%JAVA_EXE%") do set JAVA_EXE=%%~sF

if     defined CLASSPATH set C_PATH=%ITCAM_CONFIGHOME%\bin\jython\jython.jar;%ITCAM_CONFIGHOME%\bin\lib\installbundle.jar;%CLASSPATH%
if not defined CLASSPATH set C_PATH=%ITCAM_CONFIGHOME%\bin\jython\jython.jar;%ITCAM_CONFIGHOME%\bin\lib\installbundle.jar
if     defined PYTHONPATH set PYTHONPATH=%ITCAM_CONFIGHOME%\bin;%ITCAM_CONFIGHOME%\bin\lib;%PYTHONPATH%
if not defined PYTHONPATH set PYTHONPATH=%ITCAM_CONFIGHOME%\bin;%ITCAM_CONFIGHOME%\bin\lib

@REM Set the JVM options
set JAVA_OPTS=
set JAVA_PROPS=-Dpython.path="%PYTHONPATH%" 
set JAVA_TOOL_OPTIONS=

@REM echo.
@REM echo Launching ITCAM configuration...
@REM echo.
@REM echo   ITCAM_CONFIGHOME: %ITCAM_CONFIGHOME%
@REM echo.
@REM echo   JAVA_HOME:        %JAVA_HOME%
@REM echo.
@REM set p=%C_PATH%
@REM set t=  CLASSPATH:       x
@REM set t=%t:x=%
@REM :loop_CLASSPATH
@REM if not "%p%" == "" (
@REM   for /f "tokens=1,* delims=;" %%I in ("%p%") do (
@REM     if not "%%I" == "" echo %t% %%I
@REM     set p=%%J
@REM     set t=                   x
@REM     set t=!t:x=!
@REM   )
@REM   goto loop_CLASSPATH
@REM )
@REM echo.
@REM set p=%PYTHONPATH%
@REM set t=  PYTHONPATH:      x
@REM set t=%t:x=%
@REM :loop_PYTHONPATH
@REM if not "%p%" == "" (
@REM   for /f "tokens=1,* delims=;" %%I in ("%p%") do (
@REM     if not "%%I" == "" echo %t% %%I
@REM     set p=%%J
@REM     set t=                   x
@REM     set t=!t:x=!
@REM   )
@REM   goto loop_PYTHONPATH
@REM )
@REM echo.

@REM Execute the DC configurator
pushd %ITCAM_CONFIGHOME%\bin
set launchcommand="%JAVA_EXE%" -cp "%C_PATH%" %JAVA_OPTS% %JAVA_PROPS% org.python.util.jython "%ITCAM_CONFIGHOME%\bin\deletetemplatexd.py" %*
@REM echo %launchcommand%
%launchcommand%
set RC=%ERRORLEVEL%
popd

goto done

:err_noConfigHome
    echo The ITCAM_CONFIGHOME environment variable is not defined correctly
    echo This environment variable is needed to run this program
    set RC=1
    goto done
    
:err_noJavaHome
    echo The JAVA_HOME environment variable is not defined correctly
    echo This environment variable is needed to run this program
    set RC=1
    goto done

:done
if not defined RC set RC=0
endlocal & set RC=%RC%
exit /b %RC%
