#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved. 
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################
'''
   This module sets the connection, port and host in pdl.  Based on the 
   provided data from the command line, the pdl is set.
'''

import utils
from debugUtil import logDebug as debug

def set_connection(pdl):
    '''
       Sets the connection data in the PDL.
       
       @param pdl - PDL reference
    '''
    
    debug("Entry set_conection")
    
    serverlist = utils.getData(pdl, "SERVERS")
    conntype = utils.getData(pdl, "CONNTYPE")
    if (conntype is not None):
        debug("Setting CONNTYPELIST - %s" % (conntype))
        utils.setData(pdl, "CONNTYPELIST", [], "configconnection")
        for serveri in range(len(serverlist)):
            utils.getData(pdl, "CONNTYPELIST").append(conntype)
    host = utils.getData(pdl, "HOST")
    if (host is not None):
        debug("Setting HOSTLIST - %s" % (host))
        utils.setData(pdl, "HOSTLIST", [], "configconnection")
        for serveri in range(len(serverlist)):
            utils.getData(pdl, "HOSTLIST").append(host)
    port = utils.getData(pdl, "PORT")        
    if (port is not None):
        debug("Setting PORTLIST - %s" % (port))
        utils.setData(pdl, "PORTLIST", [], "configconnection")
        for serveri in range(len(serverlist)):
            utils.getData(pdl, "PORTLIST").append(port)
    
    debug("exit set_connection")   
