#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################
'''
   This module prompts the user for SMF settings.
'''

import doprompt as prompt
import platformUtil
import utils

from debugUtil import logDebug as debug


def config_smf(pdl, soa71_migrate = False):
    '''
       Prompts the user for smf settings if not already setup.

       @param pdl - PDL reference
       @param soa71_migrate - Ture if soa71 migration processing otherwise False
    '''

    debug("Entry config_smf")

    if platformUtil.IS_zOS_OS():
        #
        # If this is as the result of migrate call for soa71, then set the pdl
        # without asking question.
        #
        if ((soa71_migrate) and (not pdl["SILENT"][0])):
            utils.setData(pdl, "SMF", "0", "configsmf")
        else:
            prompt.do_prompt("SMF", pdl)

    #
    # Make the pdls for the SMF as a list for the number of
    # servers in SERVERS pdl.
    #
    smf = utils.getData(pdl, "SMF")
    if smf is None:
        smf = "Leave"
        utils.setData(pdl, "SMF", smf, "configsmf")
    utils.setData(pdl, "SMFLIST", [], "configsmf")
    serverlist = utils.getData(pdl, "SERVERS")
    for serveri in range(len(serverlist)):
        utils.getData(pdl, "SMFLIST").append(smf)

    debug("Exit config_smf")
