#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################
# This is a code page module for Jython 2.1 for IBM-1047.
# Later versions of Jython have different requirements.
#####################################################################

import codecs

class Codec(codecs.Codec):
    def encode(self,input,errors='strict'): return codecs.charmap_encode(input,errors,encoding_map)
    def decode(self,input,errors='strict'): return codecs.charmap_decode(input,errors,decoding_map)

class StreamWriter(Codec,codecs.StreamWriter): pass
class StreamReader(Codec,codecs.StreamReader): pass

def getregentry(): return (Codec().encode,Codec().decode,StreamReader,StreamWriter)

decoding_map = {}
decoding_map.update({
    0x00: 0x00,
    0x01: 0x01,
    0x02: 0x02,
    0x03: 0x03,
    0x04: 0x9c,
    0x05: 0x09,
    0x06: 0x86,
    0x07: 0x7f,
    0x08: 0x97,
    0x09: 0x8d,
    0x0a: 0x8e,
    0x0b: 0x0b,
    0x0c: 0x0c,
    0x0d: 0x0d,
    0x0e: 0x0e,
    0x0f: 0x0f,
    0x10: 0x10,
    0x11: 0x11,
    0x12: 0x12,
    0x13: 0x13,
    0x14: 0x9d,
    0x15: 0x0a, # New line / x'85' in IBM-037
    0x16: 0x08,
    0x17: 0x87,
    0x18: 0x18,
    0x19: 0x19,
    0x1a: 0x92,
    0x1b: 0x8f,
    0x1c: 0x1c,
    0x1d: 0x1d,
    0x1e: 0x1e,
    0x1f: 0x1f,
    0x20: 0x80,
    0x21: 0x81,
    0x22: 0x82,
    0x23: 0x83,
    0x24: 0x84,
    0x25: 0x85, # End of line / x'0a' in IBM-037
    0x26: 0x17,
    0x27: 0x1b,
    0x28: 0x88,
    0x29: 0x89,
    0x2a: 0x8a,
    0x2b: 0x8b,
    0x2c: 0x8c,
    0x2d: 0x05,
    0x2e: 0x06,
    0x2f: 0x07,
    0x30: 0x90,
    0x31: 0x91,
    0x32: 0x16,
    0x33: 0x93,
    0x34: 0x94,
    0x35: 0x95,
    0x36: 0x96,
    0x37: 0x04,
    0x38: 0x98,
    0x39: 0x99,
    0x3a: 0x9a,
    0x3b: 0x9b,
    0x3c: 0x14,
    0x3d: 0x15,
    0x3e: 0x9e,
    0x3f: 0x1a,
    0x40: 0x20,
    0x41: 0xa0,
    0x42: 0xe2,
    0x43: 0xe4,
    0x44: 0xe0,
    0x45: 0xe1,
    0x46: 0xe3,
    0x47: 0xe5,
    0x48: 0xe7,
    0x49: 0xf1,
    0x4a: 0xa2,
    0x4b: 0x2e,
    0x4c: 0x3c,
    0x4d: 0x28,
    0x4e: 0x2b,
    0x4f: 0x7c,
    0x50: 0x26,
    0x51: 0xe9,
    0x52: 0xea,
    0x53: 0xeb,
    0x54: 0xe8,
    0x55: 0xed,
    0x56: 0xee,
    0x57: 0xef,
    0x58: 0xec,
    0x59: 0xdf,
    0x5a: 0x21,
    0x5b: 0x24,
    0x5c: 0x2a,
    0x5d: 0x29,
    0x5e: 0x3b,
    0x5f: 0x5e, # Not sign / x'ac' in IBM-037
    0x60: 0x2d,
    0x61: 0x2f,
    0x62: 0xc2,
    0x63: 0xc4,
    0x64: 0xc0,
    0x65: 0xc1,
    0x66: 0xc3,
    0x67: 0xc5,
    0x68: 0xc7,
    0x69: 0xd1,
    0x6a: 0xa6,
    0x6b: 0x2c,
    0x6c: 0x25,
    0x6d: 0x5f,
    0x6e: 0x3e,
    0x6f: 0x3f,
    0x70: 0xf8,
    0x71: 0xc9,
    0x72: 0xca,
    0x73: 0xcb,
    0x74: 0xc8,
    0x75: 0xcd,
    0x76: 0xce,
    0x77: 0xcf,
    0x78: 0xcc,
    0x79: 0x60,
    0x7a: 0x3a,
    0x7b: 0x23,
    0x7c: 0x40,
    0x7d: 0x27,
    0x7e: 0x3d,
    0x7f: 0x22,
    0x80: 0xd8,
    0x81: 0x61,
    0x82: 0x62,
    0x83: 0x63,
    0x84: 0x64,
    0x85: 0x65,
    0x86: 0x66,
    0x87: 0x67,
    0x88: 0x68,
    0x89: 0x69,
    0x8a: 0xab,
    0x8b: 0xbb,
    0x8c: 0xf0,
    0x8d: 0xfd,
    0x8e: 0xfe,
    0x8f: 0xb1,
    0x90: 0xb0,
    0x91: 0x6a,
    0x92: 0x6b,
    0x93: 0x6c,
    0x94: 0x6d,
    0x95: 0x6e,
    0x96: 0x6f,
    0x97: 0x70,
    0x98: 0x71,
    0x99: 0x72,
    0x9a: 0xaa,
    0x9b: 0xba,
    0x9c: 0xe6,
    0x9d: 0xb8,
    0x9e: 0xc6,
    0x9f: 0xa4,
    0xa0: 0xb5,
    0xa1: 0x7e,
    0xa2: 0x73,
    0xa3: 0x74,
    0xa4: 0x75,
    0xa5: 0x76,
    0xa6: 0x77,
    0xa7: 0x78,
    0xa8: 0x79,
    0xa9: 0x7a,
    0xaa: 0xa1,
    0xab: 0xbf, # mumble / x'dd' in IBM-037
    0xac: 0xd0,
    0xad: 0x5b,
    0xae: 0xde,
    0xaf: 0xae,
    0xb0: 0xac, # mumble / x'5e' in IBM-037
    0xb1: 0xa3,
    0xb2: 0xa5,
    0xb3: 0xb7,
    0xb4: 0xa9,
    0xb5: 0xa7,
    0xb6: 0xb6,
    0xb7: 0xbc,
    0xb8: 0xbd,
    0xb9: 0xbe,
    0xba: 0xdd, # mumble / x'5b' in IBM-037
    0xbb: 0xa8, # mumble / x'5d' in IBM-037
    0xbc: 0xaf,
    0xbd: 0x5d, # mumble / x'a8' in IBM-037
    0xbe: 0xb4,
    0xbf: 0xd7,
    0xc0: 0x7b,
    0xc1: 0x41,
    0xc2: 0x42,
    0xc3: 0x43,
    0xc4: 0x44,
    0xc5: 0x45,
    0xc6: 0x46,
    0xc7: 0x47,
    0xc8: 0x48,
    0xc9: 0x49,
    0xca: 0xad,
    0xcb: 0xf4,
    0xcc: 0xf6,
    0xcd: 0xf2,
    0xce: 0xf3,
    0xcf: 0xf5,
    0xd0: 0x7d,
    0xd1: 0x4a,
    0xd2: 0x4b,
    0xd3: 0x4c,
    0xd4: 0x4d,
    0xd5: 0x4e,
    0xd6: 0x4f,
    0xd7: 0x50,
    0xd8: 0x51,
    0xd9: 0x52,
    0xda: 0xb9,
    0xdb: 0xfb,
    0xdc: 0xfc,
    0xdd: 0xf9,
    0xde: 0xfa,
    0xdf: 0xff,
    0xe0: 0x5c,
    0xe1: 0xf7,
    0xe2: 0x53,
    0xe3: 0x54,
    0xe4: 0x55,
    0xe5: 0x56,
    0xe6: 0x57,
    0xe7: 0x58,
    0xe8: 0x59,
    0xe9: 0x5a,
    0xea: 0xb2,
    0xeb: 0xd4,
    0xec: 0xd6,
    0xed: 0xd2,
    0xee: 0xd3,
    0xef: 0xd5,
    0xf0: 0x30,
    0xf1: 0x31,
    0xf2: 0x32,
    0xf3: 0x33,
    0xf4: 0x34,
    0xf5: 0x35,
    0xf6: 0x36,
    0xf7: 0x37,
    0xf8: 0x38,
    0xf9: 0x39,
    0xfa: 0xb3,
    0xfb: 0xdb,
    0xfc: 0xdc,
    0xfd: 0xd9,
    0xfe: 0xda,
    0xff: 0x9f,
})

encoding_map = {}
for key in decoding_map.keys():
    val = decoding_map[key]
    encoding_map[val] = key
