#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################
'''
    This module contains functions that create the ITCAM for AD 7.2
    runtime directory
'''

assert False, "This module is obsolete, its functions are subsumed by the runtime builder"

fixlev = "40544" # Last APAR, defect or story to update this module

import sys
import os
import shutil
import urllib

import java
from java.lang import System

import configUtils as configUtils
import shared_globals as globals
import createPCL_config as createPCL
import createPDL as createPDL
import doprompt as prompt
import utils
import debugUtil as log
import doprompt as prompt
import debugUtil
import resourcebundle

from debugUtil import logDebug as debug
from resourcebundle import getmsg as getmsg

scriptname="create_runtimes.py"

#####################################################################
# Globals                                                           #
#####################################################################

STANDALONE_TEST=0

# Dictionary of server / findServers defaults for testing purposes
server_defaults = {

       "WASCELL"               :  "beta"                               ,
       "WSHOST"                :  ""                                   ,
       "NODE"                  :  "tvt7006"                            ,
       "WASNODE"               :  "tvt7006"                            ,
       "WASINSTALLROOT"        :  "/u/WAS800B/beta/tvt7006/AppServer"                       ,
       "WASPLUGINSROOT"        :  "/u/WAS800B/beta/tvt7006/AppServer/plugins"               ,
       "USERINSTALLROOT"       :  "/u/WAS800B/beta/tvt7006/AppServer/profiles/default"      ,
       "WASCONFIGROOT"         :  "/u/WAS800B/beta/tvt7006/AppServer/profiles/default/con#fig"   ,
       "WASPROPSDIR"           :  "/u/WAS800B/beta/tvt7006/AppServer/profiles/default/properties",
       "RMIHOST"               :  "tvt7006.tivlab.raleigh.ibm.com"           ,
       "RMIPORT"               :  "9809"                                     ,
       "JAVAHOME"              :  "/u/WAS800B/beta/tvt7006/AppServer/java64" ,
       "LOGROOT"               :  "/u/WAS800B/beta/tvt7006/AppServer/profiles/default/logs",
       "WASSERVER"             :  "b8sr00a"                                  ,
       "STANDALONE"            :  "None"                                     ,
       "JVMMODE"               :  "64bit"                                    ,
       "SHARECLASSESMODIFIED"  :  "None"                                     ,
       "SERVERID"              :  "serverid=b8sr00a(cells/beta/nodes/tvt7006/servers/b8sr00a|server.xml#Server_1307487616673)"  , # FS


       "WASVER"                :  "8.0"                      ,
       "WASVERSION"            :  "80"                       ,
       "WASMAJORVER"           :  "8"                        ,
       "JVMVERSION"            :  "16"                       ,

  }

# Dictionary of common defaults for testing purposes
common_defaults = {
       "CONFIGHOME"            : "/u/mcoley/jython/CONFIG"        ,
       "MSCONNECT"             : 1     ,
       "CLEANUP"               : 1     ,
       "DEBUG"                 : 1     ,
       "BATCH"                 : 1     ,
       "RECREATERUNTIME"       : 0     ,
       "GCOUTPUT"              : 0     ,
       "GCLOGPATH"             : "JESLOG:SYSOUT:KEEP"             ,
       "MSHOME"                : "/opt/IBM/itcam/WebSphere/MS"    ,
       "DMGRHOST"              : ""                               ,
       "DEFAULTHOSTNAME"       : "TVT7006.tivlab.raleigh.ibm.com" ,
       "RMIPORT"               : "9809"                           ,
       "BINDIP"                : "9.42.47.135"                    ,
       "EXPORTIP"              : "9.42.47.135"                    ,
       "KERNELIP"              : "nc048048.tivlab.raleigh.ibm.com",
       "RFSPORT01"             : "9120"         ,
       "RFSPORT02"             : "9121"         ,
       "KERNELPORT01"          : "9122"         ,
       "KERNELPORT02"          : "9123"         ,
       "ITCAMPROBERMIPORT"     : "8200-8299"    ,
       "PROBECONTROLLERRMIPORT": "8300-8399"    ,
       "TEMAHOST"              : "127.0.0.1"    ,
       "TEMAPORT"              : "65500"        ,
       "WSHOST"                :  ""            ,
       "PLUGINS"               :  "y"           ,
       "CLEANUPPLUGINS"        :  "n"           ,

   }


#####################################################################
# Populate the runtime directories                                  #
#####################################################################

def create_runtime(pdl, SERVER, ix):
    '''
        create_runtime - create the runtime directories
        @param pdl     - reference to pdl
        @param SERVER  - server name
        @param ix      - pdl index of the server
    '''
    debug("Entry create_runtime %s" % fixlev)
    ###
    # Common
    ###
    CONFIG_HOME=       pdl_lookup("CONFIGHOME",pdl)
    MSCONNECT=         pdl_lookup("MSCONNECT",pdl)
    CLEANUP=           pdl_lookup("CLEANUP",pdl)
    DEBUG=             pdl_lookup("DEBUG",pdl)
    BATCH=             pdl_lookup("BATCH",pdl)
    RECREATERUNTIME=   pdl_lookup("CLEANUP",pdl)
    OWNER=             pdl_lookup("OWNER",pdl)
    ACCESS=            pdl_lookup("ACCESS",pdl)
    TEMACONNECT=       pdl_lookup("TEMACONNECT",pdl)
    TEMA_HOST=         pdl_lookup("TEMAHOST",pdl)
    TEMA_PORT=         pdl_lookup("TEMAPORT",pdl)
    SOADC=             pdl_lookup("SOADC",pdl)
    GCOUTPUT=          pdl_lookup("GCOUTPUT",pdl)
    GCLOGPATH=         pdl_lookup("GCLOGPATH",pdl)
    MSHOME=            pdl_lookup("MSHOME",pdl)
    DMGRHOST=          pdl_lookup("DMGRHOST",pdl)
    DEFAULTHOSTNAME=   pdl_lookup("DEFAULTHOSTNAME",pdl)
    BINDIP=            pdl_lookup("BINDIP",pdl)
    EXPORTIP=          pdl_lookup("EXPORTIP",pdl)
    KERNELIP=          pdl_lookup("KERNELIP",pdl)
    RFSPORT01=         pdl_lookup("RFSPORT01",pdl)
    RFSPORT02=         pdl_lookup("RFSPORT02",pdl)
    KERNELPORT01=      pdl_lookup("KERNELPORT01",pdl)
    KERNELPORT02=      pdl_lookup("KERNELPORT02",pdl)
    DEF_PROBE_RMI_PORT=pdl_lookup("PROBERMIPORT",pdl)
    DEF_PROBE_CONTROLLER_RMI_PORT=pdl_lookup("PROBECONTROLLERRMIPORT", pdl)
    WS_HOST=           pdl_lookup("WSHOST",pdl)

    TTAPI=             pdl_lookup("TTAPI",pdl)
    TTAPIDIR=          pdl_lookup("TTAPIDIR",pdl)
    TTAPISSN=          pdl_lookup("TTAPISSN",pdl)

   #These have stored values as a list, one entry per server.
    TTAPILIBPATH=      get_pdlx("TTAPILIBPATH",pdl, ix)
    TTAPICLASSPATH=    get_pdlx("TTAPICLASSPATH",pdl, ix)

    # findServers related
    WAS_INSTALL_ROOT=  get_pdlx("WASINSTALLROOT",pdl,ix)
    WAS_PLUGINS_ROOT=  get_pdlx("WASPLUGINSROOT",pdl,ix)
    USER_INSTALL_ROOT= get_pdlx("USERINSTALLROOT",pdl,ix)
    WAS_CONFIG_ROOT=   get_pdlx("WASCONFIGROOT",pdl,ix)
    WAS_PROPS_DIR=     get_pdlx("WASPROPSDIR",pdl,ix)
    RMI_HOST=          get_pdlx("RMIHOST",pdl,ix)
    RMI_PORT=          get_pdlx("RMIPORT",pdl,ix)
    JAVA_HOME=         get_pdlx("JAVAHOME",pdl,ix)
    WPS_HOME=          get_pdlx("WPSHOME",pdl,ix)
    WBI_HOME=          get_pdlx("WBIHOME",pdl,ix)

    WAS_CELL=          get_pdlx("WASCELL",pdl,ix)
    NODE=              get_pdlx("WASNODE",pdl,ix)
    WAS_NODE=          get_pdlx("WASNODE",pdl,ix)
    WASVER=            get_pdlx("WASVER",pdl,ix)
    JVMMODE=           get_pdlx("JVMMODE",pdl,ix)
    LOGROOT=           get_pdlx("LOGROOT",pdl,ix)
   #Server specific
    WAS_SERVER=        get_pdlx("WASSERVER",pdl,ix)
    WAS_VERSION=       get_pdlx("WASVERSION",pdl,ix)
    WAS_VERSION=       str(WAS_VERSION)
    WASVER=            get_pdlx("WASVER",pdl,ix)
    WAS_MAJOR_VER=     get_pdlx("WASMAJORVER",pdl,ix)
    JVM_VERSION=       get_pdlx("JVMVERSION",pdl,ix)
    JVM_VERSION=str(JVM_VERSION)
    WAS_MAJOR_VER=     get_pdlx("WASMAJORVER",pdl,ix)
    JVMMODE=           get_pdlx("JVMMODE",pdl,ix)

    debug("    RECREATERUNTIME=" + str(RECREATERUNTIME) )
    debug("    WS_HOST="         + str(WS_HOST) )

    # These should have been set in get_runtime_info
    RUNLOC=            get_pdlx("RUNLOC",pdl,ix)
    RUNTIME=           get_pdlx("RUNTIME",pdl,ix)
    RUNTIMEP=          get_pdlx("RUNTIMEP",pdl,ix)
    AMPLATFORM=        get_pdlx("AMPLATFORM",pdl,ix)

    debug("  create_runtime entry")
    debug("    CONFIG_HOME=" + CONFIG_HOME )
    debug("    RUNLOC="      + RUNLOC   )
    debug("    RUNTIME="     + RUNTIME )
    debug("    RUNTIMEP="    + RUNTIMEP )
    debug("    AMPLATFORM="  + AMPLATFORM )

    ############################
    # Initialization
    ############################
    osname=System.getProperty("os.name")

    DC_OPERATION_MODE=""
    AM_ITCAM_ENABLED ="NO"

    # Set DC_OPERATION_MODE
    if MSCONNECT == True:
        DC_OPERATION_MODE = "MS"
        AM_ITCAM_ENABLED  = "YES"
    if TEMACONNECT == True:
        DC_OPERATION_MODE += ",WR,HC"
    if SOADC == True:
        DC_OPERATION_MODE += ",SOA"
    if TTAPI == True:
        DC_OPERATION_MODE += ",TT"

    # To allow AD to be enabled from TPV as per story 17659
    # Commented out for now until further notice
    # DC_OPERATION_MODE += ",ECAM"

    #
    #  Display variable values
    #
    runtime_basename=os.path.basename(RUNTIME)
    debug("    RUNTIME=" + RUNTIME)
    debug("    RUNTIME base=" + runtime_basename)
    debug("  ")
    BINHOME = os.path.normpath(os.path.join(CONFIG_HOME, "bin"))

    osname = System.getProperty("os.name")


    ###################################################################################
    # 2. If the directory exists we have been allowed to either reuse or recreate it
    #    RECREATERUNTIME from get_runtime
    ###################################################################################

    if os.path.isdir(RUNTIME):
        runtime_basename=os.path.basename(RUNTIME)
        if  RECREATERUNTIME == 1:
            debug("   Requested to remove and recreate runtime directory")
            # TODO
            #    call msunconfig

            try:
                shutil.rmtree(RUNTIME)
            except Exception, msgVar:
                log.logException("  Error removing runtime directory")
            if os.path.exists(RUNTIME):
                debug("     *Warning* Unable to remove directory %s" % ( runtime_basename ) )
                debug("               Processing will continue using existing directory")
            else:
                debug("   Successfully removed directory %s" % (RUNTIME) )
        elif os.path.isdir(RUNTIME):
            debug("   Reusing existing directory %s" % (runtime_basename) )

    #####################################################################
    # 3. Verify the existence of some version specific ITCAM files      #
    #    Input: WAS_VERSION CONFIG_HOME
    #####################################################################

    # Determine itcamdc/etc directory location of was$WAS_VERSION files
    WASETC_VER=WAS_VERSION
    if not os.path.exists(CONFIG_HOME+"/itcamdc/etc/was/was"+WAS_VERSION):
        WASETC_VER=str(WAS_MAJOR_VER)
        debug("   WASETC_VER=" + WASETC_VER)
    ents=[]
    ents.append(CONFIG_HOME+"/toolkit/etc/was/was"+WAS_VERSION+"/jmxconfig_was" + WAS_VERSION + ".xml")
    ents.append(CONFIG_HOME+"/itcamdc/etc/was/was"+WASETC_VER+"/dc_config_was"+WAS_VERSION+".properties")
    if JVMMODE == "64bit":
        ents.append(CONFIG_HOME+"/toolkit/lib/libam_ibm_"+JVM_VERSION+"_64.so")
    else:
        ents.append(CONFIG_HOME+"/toolkit/lib/libam_ibm_"+JVM_VERSION+".so")
    bad_hit = False
    errmsg = ""
    for ent in ents:
        if not os.path.exists(ent):
            bad_hit = True
            errMsg = errMsg + "*Error**  Missing ITCAM support files for WAS %s: %s \n" % (WASVER, os.path.basename(ent)  )
    if bad_hit == True:
        assert False, getmsg("CFG1115E", "Unable to continue without these files: {0}", [errMsg])

    #####################################################################
    # 4. Get ITCAM installation directory name                          #
    #    TODO: clarify description of "installation directory"          #
    #####################################################################

    AM_HOME=CONFIG_HOME+"/itcamdc"
    debug("   AM_HOME=" + AM_HOME)

    #####################################################################
    # 5. If the DMGR hostname was not specified by ITCAM_DMGRHOST or    #
    #    -dmgrhost, use the value findServers got from the node.        #
    #    If findServers didn't run, use the default host name on the    #
    #    theory that the local host might be running the DMGR.          #
    #####################################################################

    if DMGRHOST == "" or DMGRHOST is None:
        debug("  DMGRHOST set from findServers data RMI_HOST")
        DMGRHOST=RMI_HOST

    if DMGRHOST == "" or DMGRHOST is None:
        debug("  DMGRHOST set from wsadmin host")
        DMGRHOST=WS_HOST
    if DMGRHOST == "" or DMGRHOST is None:
        debug("  DMGRHOST set from default hostname")
        DMGRHOST=DEFAULTHOSTNAME
    debug("    DMGRHOST=%s" % str(DMGRHOST) )

    #######################################################################
    # 6. Make sure the runtime directory structure exists and is writable #
    #######################################################################

    if os.path.exists(RUNTIME):
        create_flag=0
    else:
        create_flag=1

    # 6.1 Create the runtime directory structure
    for dirent in [ "", "custom", "FFDC", "lib", "logs", "logs/CYN", "logs/CYN/FFDC", "logs/CYN/logs" ]:
        runtime_dirent = RUNTIME+"/"+dirent
        if not os.path.isdir(runtime_dirent):
            debug("      Creating directory " + runtime_dirent)
            os.mkdir(runtime_dirent, 775)
            # TODO:   test for success
        else:
            debug("      Directory already exists:" + dirent)

        os.system("chmod -Rf a+rwX "+runtime_dirent)
        assert os.path.isdir(runtime_dirent), getmsg("CFG5021E", "Failed to create {0}", [runtime_dirent])
    if create_flag == 1:
        debug("     Directory structure created for " + RUNTIME )

    #####################################################################
    # 8. Remove obsolete input propterties in ASCII                     #
    #####################################################################
    filepath=RUNTIME+"/input.txt"
    if os.path.isfile(filepath):
        debug("    Attempting to remove obsolete input.txt")
        #rm -f $RUNTIME/input.txt
        try:
            os.remove(RUNTIME+"/input.txt")
        except Exception, msgVar:
            configUtils.display_exception(method_descr, Exception, msgVar)
            debug("     Problems removing obsolete " + filepath)

    #####################################################################
    # 9.Remove obsolete 6.1 configuration files                        #
    #####################################################################

    ####################################################################
    # 10 Attempt to migrate any existing ID or AM MOD level files     #
    ####################################################################
    runtime_runloc_id=RUNTIME+"/"+RUNLOC+".id"
    runtime_id=RUNTIME+"/id"
    runtime_runloc_ammod=RUNTIME+"/"+RUNLOC+".am.mod"
    runtime_ammod=RUNTIME+"/am.mod"
    method_descr="create_runtime-migrate existing ID and MOD files"
    try:
        if os.path.isfile(runtime_runloc_id) and not os.path.exists(runtime_id):
            debug("    Attempting to migrate ID file from " + runtime_runloc_id)
            shutil.copy2(runtime_runloc_id, runtime_id)
            os.remove(runtime_runloc_id)
        if os.path.isfile(runtime_runloc_ammod) and not os.path.exists(runtime_ammod):
            debug("    Attempting to migrate am.mod file from " + runtime_runloc_ammod)
            shutil.copy2(runtime_runloc_ammod, runtime_ammod)
            os.remove(runtime_runloc_ammod)
    except Exception, msgVar:
        configUtils.display_exception(method_descr, Exception, msgVar)
        debug("     Problems migrating existing am.mod and id files" )

    #######################################################################
    # 12. Create the custom properties file
    #######################################################################
    runtime_cust_props=RUNTIME+"/custom/datacollector_custom.properties"
    if not os.path.isfile(runtime_cust_props):
        debug("  Creating custom data collector properties file")

        encoding="ASCII"
        if osname == "z/OS":
            encoding="EBCDIC"
        file_content=["# Customer modified properties",  ]
        rc = configUtils.create_file(file_content, runtime_cust_props, encoding)
        debug("  ..RC=" + str(rc)  )

    #####################################################################
    # 13.  Determine the probe service module required                  #
    #####################################################################

    #####################################################################
    # 14.
    # java.rmi.server.codebase needs quotes for Java 1.4 and less,
    # but not for java 1.5
    # Set the -Xjit:exclude methods for Java 1.5 only
    # JITI jar and properties apply only before Java 1.5 (not at all in 7.1)
    # Afterwards use -agentlib:am instead
    #####################################################################

    # The -Xnoclassgc parameter has been unnecessary for a long time
    NOCLASSGC=""
    # The -Xshareclasses:none parameter is no longer needed
    SHARECLASSES=""
    # The JIT_EXCLUDE value was used for -Xquickstart, which is no longer required
    JIT_EXCLUDE=""
    # JITI parameters no longer used
    JITIPROPS=""
    JITI_INJECTOR=""
    JITIBOOTP=""

    if int(JVM_VERSION) < 15:
        AGENTLIB="-Xrunam:"+RUNTIMEP+"/"
    else:
        AGENTLIB="-agentlib:am="+RUNTIMEP+"/"

    #####################################################################
    # 15 Create the verbose gc file, needed for TEMA or Java 1.5       #
    #####################################################################
    GC_PARMS="-verbose:gc "

    #####################################################################
    # 16 Process the MS URL value                                       #
    #####################################################################
    MSHOME_URL=urllib.quote(MSHOME,"\\/:").replace("\\","\\\\")

    #####################################################################
    #                                                                   #
    # 17 Create and populate the runtime lib directory                  #
    #                                                                   #
    #####################################################################
    if True:
        # .1 Links for .so files
        debug("  Processing runtime/lib:" + RUNTIME+"/lib")
        symlink=""
        for LNK in ["libam.so",     "libcclog.so",  "libcffdc.so",
                    "libcclog.dll", "libcffdc.dll", "libmsg23.so"  ]:
            symlink=RUNTIME+"/lib/"+LNK
            if configUtils.isLink(symlink) == True:
                debug("    Removing: " + symlink)
                try:
                    os.remove(symlink)
                except Exception, msgVar:
                    configUtils.display_exception("create_runtime_remove symlink", Exception, msgVar)
                if configUtils.isLink(symlink) == True:
                    debug("     WARNING unable to remove symlink")
                    assert False, getmsg("CFG1116E", "Unable to remove {0} symlink {1}", ["", symlink])

        # Note:
        #   1. the AMODE64 CCLog libraries are all *.so, the 31-bit ones are *.dll
        #   2. Create a symlink named libam.so that refers to the real dll in install dirs

        if JVMMODE == "64bit":
            dllname="libam_ibm_"+JVM_VERSION+"_64.so"
        else:
            dllname="libam_ibm_"+JVM_VERSION+".so"

        runtime_dll_path=RUNTIME+"/lib/libam.so"
        debug("    Creating symlink: " + runtime_dll_path )
        cmd="ln -s "+CONFIG_HOME+"/toolkit/lib/"+dllname+" " +runtime_dll_path
        rc=configUtils.issueOSCommand(cmd)
        if rc == 0:
            debug("    Successfully created symbolic link for: %s" % ( dllname ) )
        else:
            assert False, getmsg("CFG1123E", "Failed to create {0} symlink {1}", ["", dllname])


        # .2 TTAPI symlink
        #    - Remove existing symlink if present
        #    - If TTAPI is requested, create the symlink

        #    Remove any existing ttapi symbolic link
        ttapiSymlink = RUNTIME+"/lib/ttapi"
        if configUtils.isLink(ttapiSymlink) == True:
            debug("  TTAPI - removing symlink ttapi " + ttapiSymlink)
            try:
                os.remove(ttapiSymlink)
            except Exception, msgVar:
                configUtils.display_exception("create_runtime_remove_TTAPI_symlink", Exception, msgVar)
                assert False, getmsg("CFG1116E", "Unable to remove {0} symlink {1}", ["TTAPI", msgVar])
            if configUtils.isLink(ttapiSymlink):
                assert False, getmsg("CFG1116E", "Unable to remove {0} symlink {1}", ["TTAPI", ttapiSymlink])

        #   For TTAPI configurations, create the symlink to the ITCAM for TT directory
        if TTAPI == True:
            assert TTAPIDIR is not None and TTAPIDIR != "", getmsg("CFG1117E", "{0} is required if TTAPI integration is configured", ["TTAPIDIR"] )
            assert TTAPISSN is not None and TTAPISSN != "", getmsg("CFG1117E", "{0} is required if TTAPI integration is configured", ["TTAPISSN"] )
            cmd="ln -s "+TTAPIDIR+" "+ttapiSymlink
            rc=configUtils.issueOSCommand(cmd)
            # TODO EVAL: should we fail config is symlink can't be created?
            assert configUtils.isLink(ttapiSymlink), getmsg("CFG1123E", "Failed to create {0} symlink {1}", ["TTAPI", ttapiSymlink])


    #####################################################################
    # 18. Customize the logging properties files                        #
    #     - cynlogging.properties is for Java                           #
    #     - cyn-cclog.properties is for C++                             #
    #####################################################################
    debug("    Customizing log properties files")

    #   .1 cynlogging.properties  works
    #      Note JVM process options property jlog.propertyFileDir.CYN
    #      Currently there is no editing required for this file.
    #      Currently there is no editing required for this file.
    src=CONFIG_HOME+"/toolkit/etc/cynlogging.properties"
    dest=RUNTIME
    try:
        shutil.copyfile(src, dest)
        debug("     Copied: " + os.path.basename(src) )
    except Exception, msgVar:
        log.logException("Runtime copy failed for cynlogging.properties")
        assert False, getmsg("CFG1118E", "Failed to copy properties file: {0}",  [src])


    #   .2  cyn-cclog.properties
    #       Note that this must match the environment variable set in log.properties
    #       that contains property tivoli_common_dir

    COMMON_DIR=RUNTIME+"/logs"

    src=CONFIG_HOME+"/toolkit/etc/cyn-cclog.properties"
    dest=RUNTIME+"/cyn-cclog.properties"
    substitutionsList = [SHIPPED_COMMON_DIR+":"+COMMON_DIR]
    rc = configUtils.scanReplaceFile(src, dest, substitutionsList)
    if rc == 0:
        debug("     Customized: " + os.path.basename(src) )
    else:
        debug("     Customize failed: " + os.path.basename(src) )
        assert False, getmsg("CFG1118E", "Failed to copy properties file: {0}",  [src])


    #####################################################################
    # 19. Customize log.properties                                      #
    #     Set tivoli_common_dir                                         #
    #     In z/OS, in the install directories, it's in ebcdic and needs #
    #     to be converted to ascii for runtime use.                     #
    #####################################################################


    src=AM_HOME+"/etc/log.properties"
    dest=RUNTIME+"/log.properties"

    #   1  copy
    try:
        rc = configUtils.convert_to_ascii(src, dest+".tmp")
    except:
        log.logException("Conversion to ascii failed for: " + src )
        assert False, getmsg("CFG1119E", "log.properties copy and ascii conversion failed")

    #   2. translate
    if os.path.exists(dest+".tmp"):
        substitutionsList = [ SHIPPED_RUNTIME+":"+RUNTIME ]
        rc = configUtils.scanReplaceFileASCII(dest+".tmp", dest, substitutionsList)
        #   3. cleanup
        os.remove(dest+".tmp")
    else:
        assert False, getmsg("CFG1124E", "Failed to copy file {0}", [dest])


    #####################################################################
    #     Customize the dc.env.properties file                          #
    #####################################################################
    filename="dc.env.properties"
    src=AM_HOME+"/etc/"+filename
    dest=RUNTIME+"/"+filename
    substitutionsList = [
          "QUALDIR=@{RT_WAS_NODE_NAME}.@{RT_WAS_SERVER_NAME}:QUALDIR=.",
          SHIPPED_LOG_COMMON_DIR   +":"+  RUNTIME+"/logs",
        ]
    rc = configUtils.scanReplaceFile(src, dest, substitutionsList)
    if rc == 0:
        debug("    Successfully created " + filename )
        rc = configUtils.issueOSCommand("chmod a+rw " + dest)
        if rc != 0:
            debug("    but unable to set permissions on: " + filename )
    else:
        assert False, getmsg("CFG5021E", "Failed to create {0}", [filename] )

    #####################################################################
    # 20. Customize the dc.java.properties file                         #
    #     Note the presence of a colon(:) in the substitution entry     #
    #####################################################################

    # Note - a colon(":") in the 2nd item if the list entry is tolerated because split(sep,1)
    # is used in the scan/replace routine
    if 1:
        src = AM_HOME+"/etc/dc.java.properties"
        dest= RUNTIME+"/dc.java.properties"
        substitutionsList = [
           "qualDir=@{RT_WAS_NODE_NAME}.@{RT_WAS_SERVER_NAME}" +":"+ "qualDir=.",
           SHIPPED_SECURITY_POLICY_LINE +":"+ "# java.security.policy moved to JVM arguments in zOS",
           SHIPPED_LOG_COMMON_DIR       +":"+ str(RUNTIME)+"/logs",
           SHIPPED_FILESEP              +":"+ "//",
           SHIPPED_MSHOME               +":"+ str(MSHOME_URL),
           SHIPPED_WAS_BASE_SHORT       +":"+ str(WAS_MAJOR_VER),
           SHIPPED_APPSERVER_PLATFORM   +":"+ str(AMPLATFORM),
           SHIPPED_RUNTIME_DIR          +":"+ RUNTIME,
           SHIPPED_TOOLKIT_LIB_PATH     +":"+ RUNTIME+"/lib:"+CONFIG_HOME+"/toolkit/lib",
           SHIPPED_RT_WAS_SERVER_NAME   +":"+ SERVER,
           SHIPPED_DMGR_RMI             +":"+ str(DMGRHOST)+":"+str(RMI_PORT),
           SHIPPED_ITCAMDCHOME          +":"+ str(CONFIG_HOME),
           SHIPPED_PROFILE              +":"+ "default",
           SHIPPED_WS_HOST              +":"+ str(DMGRHOST),
           SHIPPED_RT_WAS_NODE_NAME     +":"+ str(NODE),
           SHIPPED_STDOUT               +":"+ "",
           SHIPPED_RT_WAS_NODE_NAME     +":"+ str(NODE),
           SHIPPED_DC_OPER_MODE         +":"+ str(DC_OPERATION_MODE),
           SHIPPED_JLOG_COMMON_DIR_CYN  +":"+ JLOG_COMMON_DIR_CYN,       # JLOG_COMMON_DIR_CYN is a constant
           "com.ibm.tivoli.tt.api.libname=dc_ttapi" +":"+ "# commented by setupwas.sh: com.ibm.tivoli.tt.api.libname=dc_ttapi",
          ]

        rc = configUtils.scanReplaceFile(src, dest, substitutionsList)
        if rc == 0:
            debug("    Successfully created " + os.path.basename(dest))
        else:
            assert 0, getmsg("CFG5021E", "Failed to create {0}", [os.path.basename(dest)])

        # Always append this:
        recordList=[ "## Appended by %s:" % (scriptname) ,
                         "am.camtoolkit.gpe.dc.operation.mode=" + DC_OPERATION_MODE
                       ]
        if TTAPI == 1:
            debug("     TTAPI config - appending properties to dc.java.properties")
            recordList.append("## Appended by %s for TTAPI integration:" % (scriptname))
            recordList.append("com.ibm.tivoli.itcam.dc.ttapi.enable=true")
            recordList.append("com.ibm.tivoli.itcam.dc.ttapi.ttas.transport=ssn:" + TTAPISSN)

        configUtils.append_to_file(recordList, dest, encoding="EBCDIC")

    #####################################################################
    # 21. Customize the datacollector.properties file                   #
    #####################################################################

    # Note KERNELPOR02 and RFSPORT02 are not used
    if 1:
        src = AM_HOME+"/etc/datacollector.properties"
        dest= RUNTIME+"/datacollector.properties"
        substitutionsList = [
           SHIPPED_AM_HOME                      +":"+ AM_HOME                               ,
           "appserver.userid=@{APPSERVER_UID}"  +":"+ "# PK43704 Removed appserver.userid"  ,
           "appserver.password=@{APPSERVER_PWD}"+":"+ "# PK43704 Removed appserver.password",
           SHIPPED_KERNEL_HOST01                +":"+ KERNELIP                              ,
           SHIPPED_KERNEL_HOST02                +":"+ KERNELIP                              ,
           SHIPPED_PORT_KERNEL_CODEBASE01       +":"+ KERNELPORT01                          ,
           SHIPPED_PORT_KERNEL_CODEBASE02       +":"+ KERNELPORT02                          ,
           SHIPPED_PORT_KERNEL_RFS01            +":"+ RFSPORT01                             ,
           SHIPPED_PORT_KERNEL_RFS02            +":"+ RFSPORT02                             ,
           SHIPPED_PROBE_RMI_PORT               +":"+ DEF_PROBE_RMI_PORT                    ,
           SHIPPED_PROBE_CONTROLLER_RMI_PORT    +":"+ DEF_PROBE_CONTROLLER_RMI_PORT         ,
           SHIPPED_WS_HOST                      +":"+ DMGRHOST                              ,
           SHIPPED_RMI_PORT                     +":"+ RMI_PORT                              ,
           SHIPPED_ITCAM_ENABLED                +":"+ AM_ITCAM_ENABLED                      ,
           SHIPPED_MSHOME                       +":"+ MSHOME_URL                            ,
           SHIPPED_BINDIP                       +":"+ BINDIP                                ,
           SHIPPED_EXPORTIP                     +":"+ EXPORTIP                              ,
         ]
        rc = configUtils.scanReplaceFile(src, dest, substitutionsList)

        if rc == 0:
            debug("    Successfully created " + os.path.basename(dest)  )
        else:
            assert False, getmsg("CFG5021E", "Failed to create {0}", [os.path.basename(dest)])
            #TODO: fail ?

    #####################################################################
    # No longer copy the default security policy file to the runtime    #
    #####################################################################

    #####################################################################
    # 22. Customize the kwjdc.properties                                #
    #####################################################################

    # Note: @{AM_HOME} is present in this file in an obsolete entry
    # TODO: can it be removed ?
    if 1:
        src = AM_HOME+"/etc/kwjdc.properties"
        dest= RUNTIME+"/kwjdc.properties"
        substitutionsList = [
            SHIPPED_TEMA_HOST  +":"+ TEMA_HOST ,
            SHIPPED_TEMA_PORT  +":"+ TEMA_PORT ,
            SHIPPED_AM_HOME    +":"+ AM_HOME,
          ]
        rc = configUtils.scanReplaceFile(src, dest, substitutionsList)
    if rc == 0:
        debug("    Successfully created " + os.path.basename(dest)  )
    else:
        #TODO: fail ?
        assert False, getmsg("CFG5021E", "Failed to create {0}", [os.path.basename(dest)])




    #####################################################################
    # 24. Copy the probeinjectormanagerchain.properties                 #
    # TODO: determine if necessary                                      #
    #####################################################################
    if 1:
        src=CONFIG_HOME+"/toolkit/etc/probeinjectormanagerchain.properties"
        dest=RUNTIME+"/probeinjectormanagerchain.properties"
        try:
            shutil.copy2(src, dest)
        except:
            log.logException("Copy failed for: " + os.path.basename(dest) )
            debug("     *WARNING* failed to create " + os.path.basename(dest)  )
        if os.path.isfile(dest):
            debug("    Successfully created " + os.path.basename(dest)  )
        else:
            debug("     *WARNING* failed to create " + os.path.basename(dest)  )
    #####################################################################
    # 25. Customize the toolkit_custom.properties                       #
    #     ctg.filters removed in AD 7.2                                 #
    #####################################################################

    # Note incorrect use of DCHOME in toolkit_custom.properties
    if 1:
        src = AM_HOME+"/etc/toolkit_custom.properties"
        dest= RUNTIME+"/custom/toolkit_custom.properties"
        if not os.path.isfile(dest):
            #debug("    Creating custom toolkit_custom.properties")
            substitutionsList= [ SHIPPED_DCHOME  +":"+  AM_HOME ]
            rc = configUtils.scanReplaceFile(src, dest, substitutionsList)
            if rc == 0:
                debug("    Successfully created " + os.path.basename(dest)  )
            else:
                assert False, getmsg("CFG5021E", "Failed to create {0}", [os.path.basename(dest)] )
        else:
            debug("     File toolkit_custom.properties already exists" )


    #####################################################################
    # 26. Set default recording level( mod LEVEL) to 1                  #
    #                                                                   #
    # Set default recording level 1 demand unless already set           #
    # The purpose of this is to reduce the data collection overhead     #
    # to the lowest level until the DC connects to the MS.  At that     #
    # point the MS may set a higher collection level is desired.  But   #
    # there is no point incurring the extra overhead if we haven't yet  #
    # contacted the MS.                                                 #
    # We set universal write permission for the file to avoid runtime   #
    # problems if configDataCollector.jacl fails.                       #
    #####################################################################

    if 1:
        src  = AM_HOME+"/etc/am.mod"
        dest = RUNTIME+"/am.mod"
        # If and only if the file does not already exist, create it
        if not os.path.isfile(dest):
            shutil.copy2(src, dest)
            if os.path.isfile(dest):
                debug("    Successfully created " + os.path.basename(dest)  )
            else:
                debug("    *WARNING* failed to create: " + os.path.basename(dest) )
        else:
            debug("    %s already exists" % (os.path.basename(dest)) )

    #####################################################################
    # 27. Create the dcInput.txt file                                   #
    #####################################################################

    if 1:
        dc_enabled = "enable"
        if AM_ITCAM_ENABLED == "NO":
            dc_enabled = "disable"

        dest = RUNTIME+"/dcInput.txt"
        dcInput = [
            "# dcInput file created  by setupwas.sh"              ,
            "OS="                        +str(osname)             ,
            "JDK_TYPE=ibm"                                        ,
            "JDK_VERSION="               +str(JVM_VERSION)        ,
            "AM_HOME="                   +str(AM_HOME)            ,
            "DC_OPER_MODE="              +str(DC_OPERATION_MODE)  ,
            "AM_SOCKET_BINDIP="          +str(BINDIP)             ,
            "AM_SOCKET_EXPORTIP="        +str(EXPORTIP)           ,
            "APPSERVER_PLATFORM="        +str(AMPLATFORM)         ,
            "DMGR_RMI="                  +str(DMGRHOST)+":"+str(RMI_PORT) ,
            "FILESEP=//"                                          ,
            "ITCAMDCHOME="               +str(CONFIG_HOME)        ,
            "ITCAM_ENABLED="             +str(dc_enabled)         ,
            "KERNEL_HOST01="             +str(KERNELIP)           ,
            "LOG_COMMON_DIR="            +str(RUNTIME)+"/logs"    ,
            "MS_AM_HOME="                +str(MSHOME)             ,
            "PORT_KERNEL_CODEBASE01="    +str(KERNELPORT01)       ,
            "PORT_KERNEL_RFS01="         +str(RFSPORT01)          ,
            "PROBE_CONTROLLER_RMI_PORT=" +str(DEF_PROBE_CONTROLLER_RMI_PORT)  ,
            "PROBE_RMI_PORT="            +str(DEF_PROBE_RMI_PORT) ,
            "PROFILE=default"                                     ,
            "RT_WAS_NODE_NAME="          +str(NODE)               ,
            "RT_WAS_SERVER_NAME="        +str(SERVER)             ,
            "RUNTIME_DIR="               +str(RUNTIME)            ,
            "STDOUT="                                             ,
            "TEMA_HOST="                 +str(TEMA_HOST)          ,
            "TEMA_PORT="                 +str(TEMA_PORT)          ,
            "TIVOLI_COMMON_DIR="         +str(COMMON_DIR)         ,
            "TOOLKIT_LIB_PATH="          +str(CONFIG_HOME)+"/toolkit/lib"   ,
            "WAS_BASE_SHORT_VERSION="    +str(WAS_VERSION)        ,
            "WS_HOST="                   +str(DMGRHOST)           ,
            "WS_RMI_PORT="               +str(RMI_PORT)           ,
            "TTAPI="                     +str(TTAPI)              ,
            "TTAPISSN="                  +str(TTAPISSN)           ,
            "TTAPIDIR="                  +str(TTAPIDIR)           ,
          ]
        # We are building a runtime only for zOS
        rc = configUtils.create_file_ebcdic(dcInput, dest)
        if rc == 0:
            debug("    Successfully created " + os.path.basename(dest)  )
        else:
            debug("    *WARNING* failed to create  " + os.path.basename(dest) )

    #####################################################################
    # 28 Extra tasks if TTAPI enabled.                                  #
    #    If LIBPATH and CLASSPATH variables not set, set them here.     #
    #    These are used in inputproperties.py to pass the data to       #
    #    so wsadmin updates can be made.                                #
    #####################################################################
    if TTAPI == True:
        if TTAPILIBPATH   is None or TTAPILIBPATH == "":
            set_pdlx("TTAPILIBPATH",   pdl, ix, RUNTIMEP+"/lib/ttapi")
        if TTAPICLASSPATH is None or TTAPICLASSPATH == "":
            set_pdlx("TTAPICLASSPATH", pdl, ix, RUNTIMEP+"/lib/ttapi/cytapi4j.jar")
    else:
        if TTAPILIBPATH != "":
            debug("     setting TTAPILIBPATH to zero length string" )
            set_pdlx("TTAPILIBPATH",   pdl, ix, "")
        if TTAPICLASSPATH != "":
            debug("     setting TTAPICLASSPATH to one blank space" )
            set_pdlx("TTAPICLASSPATH", pdl, ix, " ")  # configdataCollectors.jacl needs the space
    #####################################################################
    # 31. Set permissions                                               #
    # Make directory contents writeable to the STCs                     #
    # The directories must have the search permission(X)                #
    # Refs: RUNTIME                                                     #
    #####################################################################

    # Set default permissions
    rc = configUtils.issueOSCommand("chmod -hRf a+rwX "+RUNTIME)

    # Allow overrides by users with root access
    if OWNER is not None or ACCESS is not None:
        configUtils.changeowner(RUNTIME, OWNER, ACCESS)
        # Set to a minimum default
        rc = configUtils.issueOSCommand("chmod -hRf a+X "+RUNTIME)


    #####################################################################
    # 29 Wrap up                                                        #
    #####################################################################
    debug("  create_runtime exit")


#####################################################################
#  pdl_lookup(name, pdl)
#####################################################################

def pdl_lookup(name, pdl):
    '''
       lookup_var(name,pdl)
         @param name - variable name
         @param pdl  - reference to PDL
    '''
    try:
        value=pdl[name][00]
        debug("  pdl lookup- %s: %s" % (name, str(value) ) )
        return value
    except:
        debug("  pdl lookup failed for %s" % ( name) )
        try:
            if STANDALONE_TEST == 1:
                if common_defaults.has_key(name):
                    value=common_defaults.get(name)
                    debug("     **SA using common defaults ** for %s=%s " % ( name, value ) )
                    return value
                else:
                    debug("     **SA ERROR** Could not locate variable: " + name )
                    return None
            else:
                debug("    *WARNING* Could not locate variable: " + name )
                return None
        except:
            debug("    *WARNING* Could not locate variable: " + name )
            return None


#####################################################################
#  get_pdlx(name, pdl, ix)
#  Currently the findServers-located  pdl entry can be a string or
#  a list.  A dictionary type entry is not expected.
#####################################################################

def get_pdlx(name, pdl, ix):
    '''
         get_pdlx(name, pdl, ix)  -   PDL lookup by server index
         @param name - variable name
         @param pdl  - reference to PDL
         @param ix   - index into servers table for the server being processed
     '''
    if STANDALONE_TEST == 1:
        if server_defaults.has_key(name):
            value=server_defaults.get(name)
            debug("  pdl lookupx - using server test value  %s=%s " % ( name, value) )
            return value
        else:
            debug("    ** no test server_defaults match for %s" % (name) )
    try:
        if  type(pdl[name][00]) == type([]) or type(pdl[name][00]) == type(()):
            value=pdl[name][00][ix]
            debug("  pdl lookupx OK %s=%s ix=%s " %  (name, str(value), str(ix) ) )
            return value
        else:
            value=pdl[name][00]
            debug("  pdl lookupx OK %s=%s without ix" %  (name, str(value)) )
            return value
    except:
        debug("  pdl lookupx failed for %s, ix: %s" % ( name, ix ))
        try:
            value=pdl[name][00]
            debug("     pdl lookupx ** common var match %s=%s" % (name, str(value) ) )
            debug("      ** WARNING ** using single element match for FS VARIABLE: %s " % ( name )  )
            return value
        except:
            debug("    **             no test match for %s" % (name ) )
            debug("      ** WARNING ** could not locate data element:%s" % (name) )
            return None


#####################################################################
#  set_pdlx(key, pdl, ix)
#####################################################################

def set_pdlx(key, pdl, ix, value):
    '''
        set_pdlx(key, pdl, ix, value)
    '''
    try:
        utils.setData(pdl, key, value, "crtRuntimes", ix)
        return
    except Exception, msgVar:
        configUtils.display_exception("set_pdlx="+key, Exception, msgVar)
        debug("     set_pdlx: failed for %s=%s ix=%s" %(key, value, ix))
        try:
            utils.setData(pdl, key, value, "crtRuntimes")
            debug("         setdata updated without index")
        except Exception, msgVar:
            configUtils.display_exception("set_pdlx="+key, Exception, msgVar)
            debug("        setdata without index failed ")
            raise


#####################################################################
#  set_pdl(key, pdl, value)
#####################################################################

def set_pdl(key, pdl, value):
    '''
        set_pdl(key, pdl, value)
        Update the PDL key's value by calling the official utils.setData method
    '''
    try:
        utils.setData(pdl, key, value, "crtRuntimes")
    except Exception, msgVar:
        configUtils.display_exception("Update PDL failed for key=%s" %(key), Exception, msgVar)
        debug("     set_pdl failed key=%s, %s, %s"  %(key, Exception, msgVar) )
        raise


#####################################################################
#   Determine the stack qualifier
#####################################################################

def get_wasqual_stackqual(pdl,ix):
    '''
        Scan the version files for WBI, WPS, etc
        Returns a two digit version-release number  and id if located
        Ex.  "6.1.0.0"  -->   "61"
    '''

    debug("Entry get_wasqual_stackqual %s" % fixlev)

    wasQualifier = "was" + str(get_pdlx("WASVERSION",pdl,ix))
    debug("  WAS version: %s" % wasQualifier)

    # stack product qualifier, inserted into runtime and am_platform names
    stackQualifier = ""

    WBIHOME = get_pdlx("WBIHOME",pdl,ix)
    WPSHOME = get_pdlx("WPSHOME",pdl,ix)

    if WBIHOME is not None and WBIHOME != "":
        # Locate WBI (process server) version file
        path = os.path.normpath(os.path.join(WBIHOME, "properties", "version", "WBI.product"))
        debug("  WBI product file: %s" % path)
        assert os.path.exists(path), getmsg("CFG1122E", "{0} home exists but {1} file is missing", ["WBI", "WBI.product"])
        wbi_version, wbi_id  = scan_version_file(path)
        debug("  WBI version/id : %s/%s" %  (wbi_version, wbi_id))
        stackQualifier = "." + wbi_id + wbi_version

    if WPSHOME is not None and WPSHOME != "":
        # Locate WPS (portal server) version file
        path = os.path.normpath(os.path.join(WPSHOME, "wps.properties"))
        debug("  WPS product file: %s" % path)
        assert os.path.exists(path), getmsg("CFG1122E", "{0} home exists but {1} file is missing", ["WPS", "wps.properties"])
        wps_version, wps_id  = scan_version_file(path)
        debug("  WPS version/id: %s/%s" % (wps_version, wps_id))
        stackQualifier = "." + "wps" + wps_version

    # To do: If ESB is to be implemented, this is the place to do it.

    debug("Exit get_wasqual_stackqual: %s, %s" % (wasQualifier, stackQualifier))
    return wasQualifier, stackQualifier


#####################################################################
#   Scan the version files for WBI, WPS, etc
#####################################################################

def scan_version_file(path):
    '''
        Scan the version files for WBI, WPS, etc
        Returns a two digit version-release number  and id if located
        Ex.  "6.1.0.0"  -->   "61"
    '''
    try:
        inLines = configUtils.ReadFile(path)
        vers = ""
        id   = ""
        for rec in inLines:
            rec = rec.lstrip().rstrip()
            if rec.startswith("version="):
                rec = rec.replace("version=","")
                versList=rec.split(".")
                vers = versList[0] + versList[1]
            elif rec.startswith("<version>"):
                rec = rec.replace("<version>","").replace("</version>","")
                versList=rec.split(".")
                vers = versList[0] + versList[1]
            elif rec.startswith("<id>"):
                rec = rec.replace("<id>","").replace("</id>","")
                id  = rec.lower()
        return vers, id
    except Exception, msgVar:
        message = "Exception %s processing version file: %s " %(msgVar, path)
        log.logException(message)
        raise message


#####################################################################
# Get the server home directory name                                #
# Sets: RUNTIME RUNTIMEP AMPLATFORM RECREATERUNTIME                 #
#       RUNLOC=was$WAS_VERSION.$NODE.$SERVER                        #
#       AMPLATFORM=was$WAS_VERSION                                  #
#       WBI_ID WBI_VERSION WPS_VERSION                              #
#       MIGDIR_FLAG MIGCLN_FLAG MIGLOC                              #
#TODO - update this list                                            #
#                                                                   #
# Refs: WPS_HOME WAS_VERSION NODE SERVER CONFIG_HOME CLEANUP        #
#       WBI_INSTALL_ROOT                                            #
#       DEBUG BATCH                                                 #
#####################################################################

def get_runtime_info(pdl, SERVER, ix):

    debug("  get_runtime_info entry: server:" + SERVER)


    CONFIG_HOME=       pdl_lookup("CONFIGHOME",pdl)      # CONFIGHOME
    CLEANUP=           pdl_lookup("CLEANUP",pdl)         # CLEANUP
    RECREATERUNTIME=CLEANUP
    DEBUG=             pdl_lookup("DEBUG",pdl)           # YES
    BATCH=             pdl_lookup("BATCH",pdl)           # YES


    # Server specific xx
    WAS_CELL=       get_pdlx("WASCELL",pdl,ix)
    NODE=           get_pdlx("WASNODE",pdl,ix)
    WAS_NODE=       get_pdlx("WASNODE",pdl,ix)
    WAS_SERVER=     get_pdlx("WASSERVER",pdl,ix)
    WAS_VERSION=    get_pdlx("WASVERSION",pdl,ix)
    WAS_VERSION=str(WAS_VERSION)

    RUNLOC=          get_pdlx("RUNLOC",pdl,ix)
    RUNTIME=         get_pdlx("RUNTIME",pdl,ix)
    RUNTIMEP=        get_pdlx("RUNTIMEP",pdl,ix)
    AMPLATFORM=      get_pdlx("AMPLATFORM",pdl,ix)

    #############################################################################
    # Runtime directory name wasXX.wpsXX.NODE.SERVER if portal server           #
    # Runtime directory name wasXX.prsYY.NODE.SERVER if process server          #
    # Runtime directory name wasXX.esbYY.NODE.SERVER if enterprise service bus  #
    # Runtime directory name wasXX.NODE.SERVER otherwise                        #
    # (ESB isn't currently implemented)                                         #
    #############################################################################

    WAS_QUALIFIER, STACK_QUALIFIER = get_wasqual_stackqual(pdl,ix)

    if RUNLOC is None or  RUNLOC == "":
        debug("    **RUNLOC not in PDL, but set here")
        RUNLOC=WAS_QUALILFIER+STACK_QUALIFIER+"."+str(NODE)+"."+str(SERVER)
        set_pdlx("RUNLOC", pdl, ix, RUNLOC)
    if RUNTIME is None or  RUNTIME == "":
        debug("    **RUNTIME not in PDL, but set here")
        RUNTIME=str(CONFIG_HOME)+"/runtime/"+str(RUNLOC)
        set_pdlx("RUNTIME", pdl, ix, RUNTIME)
    if RUNTIMEP is None or  RUNTIMEP == "":
        debug("    **RUNTIMEP not in PDL, but set here")
        RUNTIMEP="${ITCAMDCHOME}/runtime/"+str(RUNLOC)
        set_pdlx("RUNTIMEP", pdl, ix, RUNTIMEP)
    if  AMPLATFORM is None or AMPLATFORM == "":
        debug("    **AMPLATFORM not in PDL, but set here")
        AMPLATFORM=WAS_QUALIFIER+STACK_QUALIFIER
        set_pdlx("AMPLATFORM", pdl, ix, AMPLATFORM)

    debug("    WAS_VERSION=" + WAS_VERSION )
    debug("    NODE="        + NODE        )
    debug("    SERVER="      + SERVER      )
    debug("    CONFIG_HOME=" + str(CONFIG_HOME) )
    debug("    RUNLOC="      + str(RUNLOC)      )
    debug("    RUNTIME="     + str(RUNTIME)     )
    debug("    RUNTIMEP="    + str(RUNTIMEP)    )
    debug("    AMPLATFORM="  + str(AMPLATFORM  ))

    #####################################################################
    # Check for existing configuration                                  #
    #####################################################################

    RECREATERUNTIME = 0
    if os.path.isdir(RUNTIME):
        # baseRuntime=os.path.basename(RUNTIME)
        print "   " + getmsg("CFG1044I","The ITCAM configuration runtime directory exists")
        print "      %s " % (RUNTIME)
        if CLEANUP == 1 or CLEANUP == "1":
            print "    " + getmsg("CFG1045I","You may retain this directory or replace it.")
            prompt.do_prompt("CLEANUP", pdl)
            RECREATERUNTIME = utils.getDataString(pdl, "CLEANUP")
        if RECREATERUNTIME == 0 or RECREATERUNTIME == "0":
            print "    " + getmsg("CFG1046I","This directory will be reused.")

        else:
            print "    " + getmsg("CFG1048I","This directory will be recreated.")
    else:
        print "   " + getmsg("CFG1047I","The following runtime directory will be created:")
        print "     " + RUNTIME

    debug("     RECREATERUNTIME=" + str(RECREATERUNTIME) )
    debug("   get_runtime_info exit" )


#####################################################################
#   print_dict(dict_name, dict):                                    #
#####################################################################

def print_dict(dict_name, dict):
    '''
        print_dict(dict_name, dict):
    '''
    if globals.DEBUG_FLAG == 1:
        debug("     List of dictionary " + dict_name)
        keys=dict.keys()
        for key in keys:
            value=server.get(key)
            debug("      %s = %s " % (key, value) )
    return server


#####################################################################
# Set replacement strings                                           #
#####################################################################

SHIPPED_APPSERVER_PLATFORM="@{APPSERVER_PLATFORM}"
SHIPPED_ITCAM_ENABLED="@{ITCAM_ENABLED}"
SHIPPED_DC_OPERATION_MODE="@{DC_OPERATION_MODE}"
SHIPPED_DC_OPER_MODE="@{DC_OPER_MODE}"
SHIPPED_WS_HOST="@{WS_HOST}"
SHIPPED_RMI_PORT="@{WS_RMI_PORT}"
SHIPPED_ITCAMDCHOME="@{ITCAMDCHOME}"
SHIPPED_AM_HOME="@{AM_HOME}"
# The following is invalidly used for AM_HOME in toolkit_custom.properties
SHIPPED_DCHOME="@{DCHOME}"
SHIPPED_BINDIP="@{AM_SOCKET_BINDIP}"
SHIPPED_EXPORTIP="@{AM_SOCKET_EXPORTIP}"
SHIPPED_AGENTLIB="@{AGENTLIB}"
SHIPPED_FILESEP="@{FILESEP}"
SHIPPED_JIT_EXCLUDE="@{JIT_EXCLUDE}"
SHIPPED_KERNEL_HOST01="@{KERNEL_HOST01}"
SHIPPED_KERNEL_HOST02="@{KERNEL_HOST02}"
SHIPPED_LOG_COMMON_DIR="@{LOG_COMMON_DIR}"
SHIPPED_JLOG_COMMON_DIR_CYN="#jlog.common.dir.CYN"
JLOG_COMMON_DIR_CYN="jlog.common.dir.CYN"
SHIPPED_MSHOME="@{MS_AM_HOME}"
SHIPPED_NODE="@{NODE}"
SHIPPED_PORT_KERNEL_CODEBASE01="@{PORT_KERNEL_CODEBASE01}"
SHIPPED_PORT_KERNEL_CODEBASE02="@{PORT_KERNEL_CODEBASE02}"
SHIPPED_PORT_KERNEL_RFS01="@{PORT_KERNEL_RFS01}"
SHIPPED_PORT_KERNEL_RFS02="@{PORT_KERNEL_RFS02}"
SHIPPED_PROBE_RMI_PORT="@{PROBE_RMI_PORT}"
SHIPPED_PROBE_CONTROLLER_RMI_PORT="@{PROBE_CONTROLLER_RMI_PORT}"
SHIPPED_JMX_CONFIG_FILE="@{JMX_CONFIG_FILE}"
SHIPPED_NOCLASSGC="@{NOCLASSGC}"
SHIPPED_QUOTE="@{QUOTE}"
SHIPPED_RUNTIME="@{RUNTIME}"
SHIPPED_RUNTIME_DIR="@{RUNTIME_DIR}"
SHIPPED_SERVER="@{SERVER}"
SHIPPED_SERVER_ID="@{SERVER_ID}"
SHIPPED_SMF="@{SMF}"
SHIPPED_TOOLKIT_LIB_PATH="@{TOOLKIT_LIB_PATH}"
SHIPPED_WAS_MAJOR_VER="@{WAS_MAJOR_VER}"
SHIPPED_WAS_VERSION="@{WAS_VERSION}"
SHIPPED_JVM_VERSION="@{JVM_VERSION}"
SHIPPED_AM_PLATFORM="@{AM_PLATFORM}"
SHIPPED_COMMON_DIR="@{TIVOLI_COMMON_DIR}"
SHIPPED_PROBE_SERVICE="@{PROBE_SERVICE}"
SHIPPED_PROBE_SERVICE_COMMENT="@{PROBE_SERVICE_COMMENT}"
SHIPPED_EXTMBEANPROV_COMMENT="@{EXTMBEANPROV_COMMENT}"
SHIPPED_GC_PARMS="@{GC_PARMS}"
SHIPPED_TEMA_HOST="@{TEMA_HOST}"
SHIPPED_TEMA_PORT="@{TEMA_PORT}"
SHIPPED_GCLOGPATH="@{GCLOGPATH}"
SHIPPED_SHARECLASSES="@{SHARECLASSES}"

SHIPPED_COMMENT="#@COMMENT@# "
SHIPPED_CONFIG_ROOT="@{CONFIG_ROOT}"
SHIPPED_JAVA_HOME="@{JAVA_HOME}"
SHIPPED_WAS_BASE_SHORT="@{WAS_BASE_SHORT_VERSION}"
SHIPPED_WAS_HOME="@{WAS_HOME}"
SHIPPED_WAS_NODE="@{WAS_NODE}"
SHIPPED_WAS_SERVER="@{RT_WAS_SERVER_NAME}"
SHIPPED_WAS_CELL="@{WAS_CELL}"
SHIPPED_WAS_PROPS_DIR="@{WAS_PROPS_DIR}"
SHIPPED_LOG_ROOT="@{LOG_ROOT}"
SHIPPED_WPS_HOME="@{WPS_HOME}"
SHIPPED_WBI_ROOT="@{WBI_ROOT}"

SHIPPED_RT_WAS_SERVER_NAME="@{RT_WAS_SERVER_NAME}"
SHIPPED_RT_WAS_NODE_NAME="@{RT_WAS_NODE_NAME}"
SHIPPED_DMGR_RMI="@{DMGR_RMI}"
SHIPPED_PROFILE="@{PROFILE}"
SHIPPED_WS_HOST="@{WS_HOST}"
SHIPPED_STDOUT="@{STDOUT}"
SHIPPED_SECURITY_POLICY_LINE="java.security.policy=@{AM_HOME}/etc/datacollector.policy"
SHIPPED_PLUGIN_JAR="@{PLUGIN_JAR}"

# Plugins
PLUGIN_BUNDLE_MANAGER_JAR="com.ibm.tivoli.itcam.bundlemanager_7.2.0.jar"


#####################################################################
# create_runtimes - driver routine                                  #
#####################################################################

def create(pdl):
    '''
        create_runtimes
    '''
    debug("Creating runtime directories")

    ################################################
    # Initialize
    ################################################
    if globals.DEBUG_FLAG == 1:
        print "** ------------------------------------------------------------- ** "
        print "** create_runtime - initial PDL contents                         ** "
        print "** ------------------------------------------------------------- ** "
        # Long version for now.
        log.logDumpPDL(pdl,short=False,findservers=True)
        print "** ------------------------------------- ** "
        print "**     PDL dump complete                 ** "
        print "** ------------------------------------- ** "

    # Verify there is at least one server being configured
    if pdl["SERVERS"][0] is None:
        assert False, getmsg("CFG5017E", "Data element {0} of PDL has no entries", ["SERVERS"])

    # Init pdl for variables we need to set if not already set
    #       Check if this data has already been set.
    for name in ["RUNLOC", "RUNTIME", "RUNTIMEP", "AMPLATFORM",
                 "TTAPILIBPATH", "TTAPICLASSPATH"]:
        if pdl[name][1] == "Initial":
            debug("    PDL var in initial state for key: %s" % name )
            # If type not set to type([]), initialize it
            if  type(pdl[name][00]) != type([]) or type(pdl[name][00]) != type(()):
                pdl[name][0]=[]              # Initialize as a list
                pdl[name][1]="crtRuntimes"   # Indicate that we initialized it
                debug("    .. initialized as a list " )
                # Initialize the list
                for serveri in range(len(pdl["SERVERS"][0])):
                    pdl[name][0].append("")

    ###################################################
    # Create a runtime for each server being configured
    ###################################################
    try:
        print "\n" + getmsg("CFG1051I","Create runtime directories....")
        for serveri in range(len(pdl["SERVERS"][0])):
            server_name = pdl["SERVERS"][0][serveri]
            debug("  Create runtime for server: " + server_name )
            print "  " + getmsg("CFG1053I","Create runtime for server:") + " " + server_name

            get_runtime_info(pdl, server_name, serveri )
            # print "**     PDL dump after get runtime    ** "
            # log.logDumpPDL(pdl,short=False,findservers=True)
            create_runtime(pdl, server_name, serveri )

            debug("  Create runtime complete for server: "  + server_name )
            print "  " + getmsg("CFG1054I","Create runtime complete for server: ") + " " + server_name
        print getmsg("CFG1052I","Create runtime directories....completed")

    except:
        log.logException("**ERROR** Error in creating runtime directories")
        print getmsg("CFG1055E","**ERROR** Error in creating runtime directories")
        raise

    ###################################################
    # Wrap up
    ###################################################
    if globals.DEBUG_FLAG == 1:
        print "** ------------------------------------- ** "
        print "**  PDL after create runtimes            ** "
        print "** ------------------------------------- ** "
        log.logDumpPDL(pdl,short=False,findservers=True)

    debug("Creating runtime directories - complete")


#####################################################################
#  test_create                                                      #
#####################################################################

def test_create():
    '''
        test_create
    '''
    # TODO improve  Need to supply servers or will we take defaults ?
    global STANDALONE_TEST
    env_value = ""
    try:
        env_value = os.getenv("STANDALONE_TEST")
    except KeyError:
        pass
    if env_value == "y":
        STANDALONE_TEST = 1
        print "*** STANDALONE_TEST ****"
    else:
        STANDALONE_TEST = 0
        print "*** TEST RUN but not STANDALONE_TEST ****"

    configUtils.test_and_set_debug()
    pcl=createPCL.make_pcl()
    pdl=createPDL.make_pdl(pcl)
    createPDL.proc_envvar(pdl)
    createPDL.proc_cliopt(pdl,sys.argv)
    pdl["SERVERS"][0] = ["b8sr00a",]
    log.logDumpPDL(pdl,short=False,findservers=True)
    print "Testing using server defaults "
    # Init log
    logfile = utils.getData(pdl,"LOG")
    print " Set logging to: " + str(log)
    debugUtil.set_logging(logfile)

    # Initialize the resource bundle
    print " Set resource bundle"
    resourcebundle.set_resourcebundle()
    # Create the runtime using this module
    create(pdl)

    return pdl


#####################################################################
#  Direct module execution runs a test environment                  #
#####################################################################

if __name__ == "__main__":

    import sys
    import os
    import shutil
    import java
    from java.lang import System
    import configUtils as configUtils
    import shared_globals as globals
    import createPCL_config as createPCL
    import createPDL as createPDL
