#####################################################################
# Licensed Materials - Property of IBM 
#
# 5724-L62  
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved. 
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
# 
#####################################################################
# 
# This module prompts for a password using SDK 1.6's java.io.Console. 
#    
#####################################################################

from java.lang import System
try: 
    import java.io.Console
except:
    pass       
import codecs            
import configUtils
import platformUtil
import debugUtil as log
from resourcebundle import getmsg

if platformUtil.IS_OS400_OS():
    import com.ibm.tivoli.itcam.dc.util.PasswordReader as PasswordReader

def getpass(prompt="Password: "):
    """
        Prompt for password
        @param prompt - prompt message     
    """  
    log.logDebug("getpass_console.getpass entry")
    
    if platformUtil.IS_OS400_OS():
        releaseElements = platformUtil.getJavaRelease().split(".")
        
        if int(releaseElements[1]) > 5:
            cons = System.console()
        else:
            cons = None
    else:
        cons = System.console()
    
    passwd = ""
    if platformUtil.IS_zOS_OS():
        if cons is not None:
            passwd = cons.readPassword(prompt.encode('cp1047'))
        else:
            print "%s" % getmsg("CFG5029I", "Warning - Error disabling echo in the terminal, password will be displayed as clear text.")
            print
            passwd = raw_input(prompt.encode('cp1047'))
        passwd = passwd.tostring().rstrip('\x15') 
        pw_ascii = configUtils.convert_ebcdic_to_ascii(passwd)
        log.logDebug("getpass_console.getpass exit")  
        return pw_ascii
    else:
        if cons is not None:
            passwd = cons.readPassword(prompt)
            passwd = passwd.tostring().rstrip('\n')
        else:
            adminPassword = PasswordReader(prompt)
            passwd = adminPassword.getIt()
#            else:
#                print "%s" % getmsg("CFG5029I", "Warning - Error disabling echo in the terminal, password will be displayed as clear text.")
#                print
#                print prompt
#                passwd = raw_input()
#                passwd = passwd.tostring().rstrip('\n') 
        log.logDebug("getpass_console.getpass exit")  
        return passwd         


if __name__ == "__main__":
    log.set_logging()
    print "Unit test - getpass_console"
    local_answer = ""
    while True:
        passwd = getpass("Enter password: ")
        print  "**Password entered is: " + passwd
       
 
