#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################

from debugUtil import logDebug as debug 
import sys, time, thread  
import codecs

'''
Module uses masking thread to hide user input in password field. Used on windows platforms where jython's getpass() fails
'''

sys.stderr = codecs.getwriter('utf-8')(sys.stderr)
sys.stdout = codecs.getwriter('utf-8')(sys.stdout)
    
def __hideInput(stream):  
    __hideInput.do_hide = 1  
    while __hideInput.do_hide:  
        stream.write("\b ")  
        stream.flush()  
        time.sleep(0.005)  
         
   
def local_getpass(prompt="Password: ", stream=None):
    debug("local_getpass entry")
    if stream == None:
        stream = sys.stderr 
    else:
        stream =  codecs.getwriter('utf-8')(stream)
    prompt = prompt.strip() + " "
    prompt = unicode(prompt)    
    #stream.write(prompt) 
    #stream.flush()
    print >> stream, prompt
    stream.flush()
    thread.start_new_thread(__hideInput, (stream,))  
    password = raw_input()  
    __hideInput.do_hide = 0
    debug("local_getpass exit")
    return password

####Main#### 
###overwrite getpass
getpass = local_getpass
