#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################
import sys
import getpass as getpass_org
import getpass_loc
from debugUtil import logDebug as debug

'''
    Module that handle password prompt in case we are not connected to tty
'''

def getpass(prompt="Password", stream=None):
    password = ""
    debug("getpass entry")
    if sys.stdin.isatty():
        debug("Using tty getpass")
        try:
            password = getpass_org.getpass(prompt, stream)
        except UnicodeEncodeError:
            debug("Non-ascii characters, getpass can not handle")
            password = getpass_loc.getpass(prompt, stream)
    else:
        debug("No tty, using masking thread")
        password = getpass_loc.getpass(prompt, stream)
        #password = sys.stdin.readline().rstrip()
    debug("getpass exit")
    return password

