####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################
#
#  This module displays help content
#
#  To use, for example:
#      import help
#      help.display(pdl, help.CONFIG )   
#  
#####################################################################
import sys

import utils
#import debugUtil
import debugUtil
import createPCL_config as createPCL    
import createPDL as createPDL
import debugUtil
from debugUtil import logDebug as debug
from resourcebundle import getmsg as getmsg

# Help pages supported
CONFIG = "config"
UNCONFIG = "unconfig"
MIGRATE = "migrate"
RECONFIG = "reconfig"

#Dictionary of feature to HELP_display mapping

help_mapping_dict = { 
                      CONFIG   : "HELP_CONFIG",  
                      UNCONFIG : "HELP_UNCONFIG",  
                      RECONFIG : "HELP_RECONFIG",
                      MIGRATE  : "HELP_MIGRATE",
                    }
               
def display(pdl, page_name ):
    '''
       Displays the help page requested   
       @param pdl - PDL reference
       @param page_name - name of the help page to display 
    '''                   
    debug("help.display - entry for %s" % page_name)
    if help_mapping_dict.has_key(page_name):
        try:
            help_resource_key = help_mapping_dict.get(page_name)
            print getmsg(help_resource_key, help_resource_key) 
        except Exception, msgVar:
            debugUtil.logException("Resource key lookup exception on %s" % help_resource_key ) 
            raise   
    else:
      raise SystemError("Invalid help page requested")
  
    debug("help.display - exit")    
    
 
if __name__ == "__main__":
    print "Unit testing of help"
    #
    #  TODO: THIS NEEDS WORK 
    #
    sys.path.append("lib")
    # Initialize PDL  
    pcl=createPCL.make_pcl()
    pdl=createPDL.make_pdl(pcl)
    createPDL.proc_envvar(pdl)
    createPDL.proc_cliopt(pdl,sys.argv)
    # Init log
    log = utils.getData(pdl,"LOG")
    print " set logging to: " + str(log)
    debugUtil.set_logging(log)
    
    help_list = [CONFIG, UNCONFIG, MIGRATE, RECONFIG] 
    for page in help_list:
        print "Test display: %s" % page  
        try:
            display(pdl, page) 
        except SystemError:
            #   except Exception, msgVar:
            print "Invalid page requested" 
        except Exception, msgVar:
            print "Help page failed  %s" % msgVar 
 
                        
