#####################################################################
# Licensed Materials - Property of IBM
#
# 5724-L62
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#####################################################################

'''
    Invoke unconfigDataCollector.py 
'''
#
#
#####################################################################

import debugUtil
import utils
import platformUtil
import wasdiscover
import doprompt
import msunconfig
import resourcebundle

from constants import constants
from UnconfigTask import UnconfigTask


def unconfigDataCollector(pdl):
    '''
       Creates unconfigtask object which executes the wsadmin for the unconfiguring the servers.
       
       @param pdl - PDL reference
       @param serverindex_list - A list of server indexes which are needed to be notified because there
                                 are probe changes.
    '''       
    debugUtil.logDebug("unconfigDataCollector entry")
    try:
            
        #
        # Instantiate common constants class
        #
        common_constants = constants()    
                      
        unconfig_task = UnconfigTask(pdl, common_constants.UNCONFIG, "unconfig_inputlist", "unconfigdatacollector.log", "unconfigDataCollector.py")
        unconfig_task.process()
        debugUtil.logDebug("unconfigDataCollector exit")
        
    except Exception, errmsg: 
        msg1 = "Error occurred processing unconfiguration - %s" % (errmsg)  
        debugUtil.logException(msg1)
        debugUtil.logDebug("unconfigDataCollector exit")
        raise errmsg
        

#####################################################################
# Unit Testing
#####################################################################

if __name__ == '__main__':

    import createPCL_config as createPCL
    import createPDL

    from debugUtil import logDebug as debug

    debugUtil.set_logging()
    debug("Unit Test for configDC")

    pdl = createPDL.make_pdl(createPCL.make_pcl())

    unconfigDataCollector(pdl)

