#!/bin/sh

#####################################################################         
# Licensed Materials - Property of IBM
#  
# 5724-L62     
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved.      
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
##################################################################### 

export CURRENT_DIRECTORY=$PWD
CLASSPATH=$CLASSPATH:$CURRENT_DIRECTORY/jython/jython.jar:$CURRENT_DIRECTORY/lib/installbundle.jar:$CURRENT_DIRECTORY/lib/i5passUtil.jar
export ITCAM_CONFIGHOME=$CURRENT_DIRECTORY/..

echo CURRENT_DIRECTORY=$CURRENT_DIRECTORY
echo CLASSPATH=$CLASSPATH
echo ITCAM_CONFIGHOME=$ITCAM_CONFIGHOME
echo                           
                               
ampassInst.sh $ITCAM_CONFIGHOME
rc=$?

if [ "$rc" != "0" ] 
then                
   exit 1           
fi                  

launch_command="java -cp $CLASSPATH org.python.util.jython"
launch_command="$launch_command $CURRENT_DIRECTORY/config.py $*"
launch_command="$launch_command -reconfig -log $CURRENT_DIRECTORY/../data/reconfig.log"

echo
echo "Launching ITCAM reconfiguration ............"
echo
echo "Log files will be created at $CURRENT_DIRECTORY/../data/reconfig.log"
echo
echo "$launch_command" 

$launch_command
rc=$?
 
exit $rc
