@REM THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
@REM 5724-i63, 5724-H88 (C) COPYRIGHT International Business Machines Corp., 2011
@REM All Rights Reserved * Licensed Materials - Property of IBM
@REM US Government Users Restricted Rights - Use, duplication or disclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.

@setlocal
@echo off

@REM --------   argument handling ---------------
set ARGS=%*

set action=Configuration
:argloop
if "%1" == "--options" goto gotoptfile
if "%1" == "--unconfig" set action=Unconfiguration
if "%1" == "" goto default
shift
goto argloop
:gotoptfile
set optfile=%2
goto process
:default
set optfile=dev-edition.properties
:process

@REM -------    get washome from options file ----

for /f "delims==, tokens=1,2" %%x in (%optfile%) do (
    if /i appserver.basedir==%%x (
       set WAS_HOME=%%~sy
       goto gotwashome
       )    
)

:gotwashome

set CONFIG_JAR=config_DC.jar
set CLASSPATH=%CONFIG_JAR%

@REM ------- set up remaining items ------------
set JAVA_EXE=%WAS_HOME%\java\bin\java.exe

pushd "%~dp0"
set CONFIG_DC_HOME=%cd%
cd ..
set DC_HOME=%cd%
cd %CONFIG_DC_HOME%


set LOG_CYN_DIR=%DC_HOME%\logs\CYN\logs
echo %LOG_CYN_DIR%
IF NOT EXIST %LOG_CYN_DIR% mkdir %LOG_CYN_DIR%
set LOG_CYN_FILE=%LOG_CYN_DIR%\trace_config.log

echo [INFO] Launching ITCAM for WebSphere Application Diagnostics Developer Edition Configuration Tool

cd /D "%CONFIG_DC_HOME%"
"%JAVA_EXE%" ^
-Djlog.propertyFileDir.CYN="%DC_HOME%\etc" ^
-classpath %CLASSPATH% com.ibm.tivoli.itcam.install.was.de.PreConfigurator %ARGS% 1> "%LOG_CYN_FILE%"  2>&1 

if ERRORLEVEL 1 goto prefail
if ERRORLEVEL 0 goto config
:prefail
echo [ERROR] Problem in PreConfigurator, please see logs in %LOG_CYN_DIR% for more information
goto end

:config
"%JAVA_EXE%" ^
-Djlog.propertyFileDir.CYN="%DC_HOME%/etc" ^
-jar %CONFIG_JAR% %ARGS% 1> "%LOG_CYN_FILE%"  2>&1

if ERRORLEVEL 1 goto fail
echo [INFO] %action% was successful. Restart the server to activate the new configuration
goto end
:fail
echo [ERROR] %action% failed, please see logs in %LOG_CYN_DIR% for more information
:end
popd

