@echo off

@REM    Licensed Materials - Property of IBM
@REM
@REM    5725-K40
@REM
@REM    (C) Copyright IBM Corp. 2011, 2013  All Rights Reserved.
@REM    US Government Users Restricted Rights - Use, duplication or
@REM    disclosure restricted by GSA ADP Schedule Contract with
@REM    IBM Corp.

setLocal enableExtensions enableDelayedExpansion
cd /d %~dp0

@REM Check work products of WebSphere's setupCmdLine.bat

if not defined WAS_HOME (
  echo.
  echo *Error*  WAS_HOME is not defined.  
  echo          Has setupCmdLine.bat been run?
  echo.
  exit /b 1
)
if not defined JAVA_HOME (
  echo.
  echo *Error*  JAVA_HOME is not defined.  
  echo          Has setupCmdline.bat been run?
  echo          Is %WAS_HOME% a valid WebSphere home?
  echo.
  exit /b 1
)

@REM Check that we are in the right place at the right time

if not exist ..\lib\ext\gdcclient.jar (
  echo.
  echo *Error*  Unable to access gdcclient.jar, current home probably incorrect
  echo          Current home directory: %CD%
  echo.
  exit /b 1
)

if "%~1" == "" (
  echo.
  echo *Warning*  No command line arguments provided for offlineCollector.bat
  echo.
  echo          Although technically there are no required arguments for this
  echo          script, some parameters usually be specified for successful
  echo          execution.
  echo.
  echo          Please note that all parameters are case-sensitive unless
  echo          explicitly specified otherwise.
  echo.
  echo          Arguments are specified as key=value pairs on the command
  echo          line and in any file specified by the input= keyword parameter:
  echo.
  echo     outfile=^<filename^> - The file name of the output JSON file.
  echo                          To avoid problems a complete path should be used.
  echo                          The directory which will contain this file must
  echo                          already exist.  The file will be written by the
  echo                          ITCAM Data Collector running within the WebSphere
  echo                          Application Server.  The offline collector will
  echo                          prompt you for a value if this is not otherwise
  echo                          supplied.
  echo.
  echo     userid=^<WAS userid^> - Use if and only if global security is enabled.
  echo     password=^<WAS password^> - Use if and only if global security is enabled.
  echo.
  echo     port=^<connection port^> - Connection port number, default is 8880.
  echo                          This is required if global security is enabled
  echo                          and the default is not adequate.
  echo     conntype=^<SOAP^|RMI^> - Connection type defaults to SOAP.
  echo     host=^<name or IP address^> - Where WAS is running, default is localhost.
  echo.
  echo     cell=^<cell^>        - The cell name is not required, use for validation.
  echo     node=^<node^>        - Usually not required.  May be needed for ND.
  echo     server=^<server^>    - Usually not required.  May be needed for ND.
  echo.
  echo     remoteKeyName=^<name^> - Needed only when global security is enabled
  echo                          and the remote key store name is not the usual
  echo                          default of NodeDefaultTrustStore.
  echo.
  echo     trustStore=^<trust file^> - Not required, default is to create and sign a
  echo                          temporary trust store file.  If specified it must
  echo                          be the full path to the WAS trust store file or a
  echo                          copy of that file.
  echo     trustStorePassword=^<trust password^> - Not required, needed only when the
  echo                          trust store is specified and the password for
  echo                          that file is not the default of WebAS.
  echo.
  echo     input=^<filename^>   - May be used to specify a file containing an
  echo                          alternative source of key/value pairs.
  echo.

)

@REM Locate Java, prefer the JRE directory

set "JAVA_HOME=%JAVA_HOME:"=%"
set "JAVA_HOME=%JAVA_HOME:/=\%
set JAVA_PATH=
if exist "%JAVA_HOME%\bin\java.exe"     set JAVA_PATH="%JAVA_HOME%\bin"
if exist "%JAVA_HOME%\jre\bin\java.exe" set JAVA_PATH="%JAVA_HOME%\jre\bin"
if not defined JAVA_PATH (
  echo.
  echo *Error*  Unable to locate java.exe
  echo.
  exit /b 1
)
PATH %JAVA_PATH%;%PATH%

@REM Invoke the offline client

java -jar ..\lib\ext\gdcclient.jar env=was %*
endLocal & exit /b %errorlevel%
