@echo off
setlocal

REM *************************************************************************
REM
REM Licensed Materials - Property of IBM
REM
REM 5724-CYN
REM
REM (C) Copyright IBM Corp. 2005,2014  All Rights Reserved.
REM
REM US Government Users Restricted Rights - Use, duplication or
REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
REM
REM *************************************************************************
REM @(#)48 1.39 itcam.dc/ppe.probe/bin/cyn_collector.cmd, itcam.dc-ppe.probe, itcam_wr_dev, 201012051900 6/22/10 12:14:45
REM *************************************************************************

Set CMD_ARG=%1
Set OUTPUT_FILE_SUFFIX=%2
Set FIRST_CHAR=%CMD_ARG:~0,1%
if "%FIRST_CHAR%"=="-" (
  if "%~1"=="-a" goto firstSettings
) else (
  goto firstSettings
)

goto help

:firstSettings
set VERSION=7.3.0.10.0
rem set VERSION=@cdc.version@
echo =============================
echo  %~n0%~x0 v%VERSION% 
echo =============================

set DC_VERSION= 
set filter= 
set CONFIGURED=
set DEFCOMDIR="C:\PROGRA~1\ibm\tivoli\common"
set CYNCOLLOG_NAME=cyn_collector.log
set CYNCOLLOG="%TEMP%\%CYNCOLLOG_NAME%"
set CONFIG=config
REM set timestamp to provide unique name to data collection
set TIMESTAMP=%DATE:~-4%%DATE:~-7,-5%%DATE:~-10,-8%%TIME:~0,2%%TIME:~3,2%%TIME:~6,2%

if "%OUTPUT_FILE_SUFFIX%" EQU "" (
  Set OUTPUT_FILE_SUFFIX=%TIMESTAMP%
) 


echo AD7.2 (or higher) detected...
set WASCOLLECTION=%1
cd "%~dp0\..\.."
set PROD_HOME=%CD%

@REM If JAVA_HOME is not defined, check the ITM location
set SCRIPT_LOCATION=%~dp0
set trial_javahome=%SCRIPT_LOCATION%..\..\..\..\java\java70_x64\jre
if not defined JAVA_HOME (
  if exist %trial_javahome%\bin\java.exe (
    set JAVA_HOME=%trial_javahome%
    echo.
    echo *Warning*  JAVA_HOME was not defined, defaulting to %trial_javahome%	
	echo *Warning*  JAVA_HOME was not defined, defaulting to %trial_javahome% >> %CYNCOLLOG%
    echo.
  )
)

@REM Remove quotes from JAVA_HOME
set dequote=###%JAVA_HOME%###
set dequote=%dequote:###"=%
set dequote=%dequote:"###=%
set dequote=%dequote:###=%
set JAVA_HOME=%dequote%

@REM Validate Java Home
if not exist "%JAVA_HOME%\bin\java.exe" if exist "%JAVA_HOME%\jre\bin\java.exe" set JAVA_HOME=%JAVA_HOME%\jre

if defined JAVA_HOME goto startInitialEcho:
echo JAVA_HOME is not defined. Please define it and try again.
goto end:

goto startInitialEcho

REM *********************************************************
REM                   startInitialEcho
REM *********************************************************
:startInitialEcho

  set SERVER_CORRECT=

  echo ============================= > %CYNCOLLOG%
  echo  %~n0%~x0 v%VERSION% >> %CYNCOLLOG%
  echo ============================= >> %CYNCOLLOG%

  echo Tool information is being logged in file %CYNCOLLOG%

rem if "%VERSION%" GEQ "@cdc.previous.version@" goto AD72_Collection
if "%VERSION%" GEQ "7.3.0.2.0" goto AD72_Collection

if "%GENERAL_DC_VERSION%" EQU "61" goto invokeFor61
for /D %%X in (7.1*) do call :DCInstance %%X %WASCOLLECTION%
goto afterInvokeFor61

:invokeFor61
set Y="61"
call :DCInstance "%1" %WASCOLLECTION%
goto afterInvokeFor61

REM *********************************************************
REM                   afterInvokeFor61
REM *********************************************************
:afterInvokeFor61

goto collectGralInfo:

:DCInstance
if "%GENERAL_DC_VERSION%" EQU "61" goto variablesFor61 
set DC_VERSION=%1
set WAS_COLLECTION=%2
rem workaround for eCAM mode: it is required to iterate all WAS servers but it is not required to collect WAS info
set REAL_WAS_COLLECTION=%2
set PROD_HOME=%BASE_PROD_HOME%\%1%\itcamdc
set VAR=%BASE_PROD_HOME%\%1%\runtime
if exist %VAR%\nul set RUNTIME_DIR=%VAR%
goto aftervariablesFor61 

:variablesFor61 
set DC_VERSION=""
set REAL_WAS_COLLECTION=%1
set WAS_COLLECTION=%2
set PROD_HOME=%BASE_PROD_HOME%
set VAR=%BASE_PROD_HOME%\..\runtime
if exist %VAR%\nul set RUNTIME_DIR=%VAR%
goto aftervariablesFor61 


:aftervariablesFor61

set CONFIGURED=

if not exist "%PROD_HOME%\\..\\runtime" goto configurationFORK
chdir /d "%PROD_HOME%\\..\\runtime"

for /D %%R in (*) do if exist "%PROD_HOME%\\..\\runtime\\%%R\\dc.java.properties" set CONFIGURED=TRUE

:configurationFORK

if "%CONFIGURED%" == "" goto definitionsSECTION:


if "%GENERAL_DC_VERSION%" EQU "61" goto afterJava
if not exist "%PROD_HOME%\\..\\..\\config\\configured" goto oldConfig:
set CONFIG_CELLS=%BASE_PROD_HOME%\config\configured
goto endConfig:
:oldConfig
set CONFIG_CELLS=%BASE_PROD_HOME%\%DC_VERSION%\installer\configured
:endConfig


:definitionsSECTION
if not exist "%PROD_HOME%\\..\\..\\..\\..\\java\\java50\\jre" goto afterJava:
chdir /d "%PROD_HOME%\\..\\..\\..\\..\\java\\java50\\jre"
set JAVA_HOME=%CD%
cd %PROD_HOME%

:afterJava
echo ========================================================== >> %CYNCOLLOG%
echo     Definitions... >> %CYNCOLLOG%
echo ========================================================== >> %CYNCOLLOG%
echo DC_VERSION=%DC_VERSION% >> %CYNCOLLOG%
echo PROD_HOME=%PROD_HOME% >> %CYNCOLLOG%
echo BASE_PROD_HOME=%BASE_PROD_HOME% >> %CYNCOLLOG%
echo COMDIR=%COMDIR% >> %CYNCOLLOG%
echo JAVA_HOME=%JAVA_HOME% >> %CYNCOLLOG%
echo CONFIG_CELLS=%CONFIG_CELLS% >> %CYNCOLLOG%

if exist "%CONFIG_CELLS%" set CONFIGURED=TRUE
echo CONFIGURED=%CONFIGURED% >> %CYNCOLLOG%

if "%WASCOLLECTION%" == "" goto regularFlow:

if %WASCOLLECTION%==-a goto regularFlow:
set filter=%WASCOLLECTION%

:regularFlow
echo filter=%filter% >> %CYNCOLLOG%
if "%filter%" EQU "" set SERVER_CORRECT=TRUE
if "%filter%" EQU " " set SERVER_CORRECT=TRUE
if "%filter%" EQU "-a" set SERVER_CORRECT=TRUE


chdir /d %PROD_HOME%

set TMPDIR=%TEMP%\CYN
set DESTNAME=%COMPUTERNAME%-CYNenv-%OUTPUT_FILE_SUFFIX%
set JARDESTDIR=%TMPDIR%\%DESTNAME%
set DESTDIR=%TMPDIR%\%DESTNAME%\
set DESTTMPDIR=%DESTDIR%\tmp
set DESTDCDIR=%DESTDIR%\DC\%DC_VERSION%
set DESTDCLOGSDIR=%DESTDCDIR%\common_logs
set DESTGRALDIR=%DESTDIR%\general
set DESTWASDIR=%DESTDIR%\was
set JAR="%JAVA_HOME%\bin\java.exe" 
set JAVA=%JAVA_HOME%\bin\java
set TOOLKIT=%PROD_HOME%\..\toolkit

set CLASSPATH=%PROD_HOME%\lib\ext\ppe.probe.jar;.;%TOOLKIT%\lib\bcm-bootstrap.jar;%TOOLKIT%\lib\ext\cdn.jar;%TOOLKIT%\lib\ext\jffdc.jar;%TOOLKIT%\lib\ext\jflt.jar;%TOOLKIT%\lib\ext\jlog.jar;%TOOLKIT%\lib\ext\tk_jflt.jar;%TOOLKIT%\lib\ext\aspectjrt.jar;

if exist "%JARDESTDIR%.zip" del /f /q %JARDESTDIR%.zip
if exist "%JARDESTDIR%.jar" del /f /q %JARDESTDIR%.jar

if not exist %DESTDIR% md %DESTDIR%

echo TMPDIR=%TMPDIR% >> %CYNCOLLOG%
echo DESTNAME=%DESTNAME% >> %CYNCOLLOG%
echo DESTDIR=%DESTDIR% >> %CYNCOLLOG%
echo DESTTMPDIR=%DESTTMPDIR% >> %CYNCOLLOG%
echo DESTDCDIR=%DESTDCDIR% >> %CYNCOLLOG%
echo DESTDCLOGSDIR=%DESTDCLOGSDIR% >> %CYNCOLLOG%
echo DESTGRALDIR=%DESTGRALDIR% >> %CYNCOLLOG%
echo DESTWASDIR=%DESTWASDIR% >> %CYNCOLLOG%
echo JAR=%JAR% >> %CYNCOLLOG%
echo JAVA=%JAVA% >> %CYNCOLLOG%
echo TOOLKIT=%TOOLKIT% >> %CYNCOLLOG%
echo CLASSPATH=%CLASSPATH% >> %CYNCOLLOG%


REM ********************************************************************************************************
REM ********************************************************************************************************
REM ***                                     Create Structure
REM ********************************************************************************************************
REM ********************************************************************************************************

echo ========================================================== >> %CYNCOLLOG%
echo     Creating Structure... >> %CYNCOLLOG%
echo ========================================================== >> %CYNCOLLOG%

if not exist %DESTGRALDIR% md %DESTGRALDIR%



REM ********************************************************************************************************
REM ********************************************************************************************************
REM ***                                     CURRENT DC COLLECTION 
REM ********************************************************************************************************
REM ********************************************************************************************************


echo Collecting DC information ...

echo     Collecting log files ...
if exist ..\logs xcopy ..\logs "%DESTDCDIR%\logs" /y /q /s /i /r >nul

echo     Collecting configuration files ...
xcopy etc %DESTDCDIR%\itcamdc\etc /y /q /s /i /r >nul
if exist ..\runtime xcopy ..\runtime "%DESTDCDIR%\runtime" /y /q /s /i /r >nul

REM don't remove the following Anchor, only activated in J2 DC.
REM Anchor_for_ITCAMfJ2_Specific_Collector

:wasCollection

REM ********************************************************************************************************
REM ********************************************************************************************************
REM ***                                     WAS COLLECTION 
REM ********************************************************************************************************
REM ********************************************************************************************************

echo ========================================================== >> %CYNCOLLOG%
echo     WAS Collection... >> %CYNCOLLOG%
echo ========================================================== >> %CYNCOLLOG%

set SUPPORTED=
if exist "%CONFIG_CELLS%" set SUPPORTED=TRUE

echo SUPPORTED=%SUPPORTED% >> %CYNCOLLOG%

if defined CONFIGURED goto configuredDC
goto end

:configuredDC

if not exist "%DESTDCDIR%" md "%DESTDCDIR%"
if not exist "%DESTDCLOGSDIR%" md "%DESTDCLOGSDIR%"

if not defined WASCOLLECTION goto GRALWASINFO:

REM **********************************************
REM **          Generating *.srv files          **
REM **********************************************

if %REAL_WAS_COLLECTION%=="" goto was_logging_not_real_on:

echo Collecting WAS information ...
echo !!! Collecting WAS information ... >> %CYNCOLLOG%

if not exist "%DESTWASDIR%" md "%DESTWASDIR%"

:was_logging_not_real_on

:GRALWASINFO

if defined SUPPORTED goto REGULARWAS:
REM ##########################################################################
REM ##  WAS CE's log collection
REM ##########################################################################

echo WAS CE's log collection ...
echo !!! WAS CE's log collection ... >> %CYNCOLLOG%

set validServer=

chdir /d "%PROD_HOME%\\..\\installer\\_uninst\\configured\\wasce"

for /F "delims== tokens=1,2" %%V in ('findstr "SERVER_HOME=" *.properties') do set CE_SERVER_HOME=%%W
for /F "delims== tokens=1,2" %%V in ('findstr "SERVER_UNAME=" *.properties') do set CE_SERVER_NAME=%%W

if "%WASCOLLECTION%" EQU "-a" set validServer=true
if "%WASCOLLECTION%" == "" set validServer=true
if "%WASCOLLECTION%" == "%CE_SERVER_NAME%" set validServer=true

if not defined WASCOLLECTION goto writeDCLogs:

md "%DESTWASDIR%\\%CE_SERVER_NAME%\\var\\catalina"

for /F "delims=\ tokens=1*" %%V in ("%CE_SERVER_HOME%") do set CE_HOME=%%V%%W

if exist "%CE_HOME%\\var\\log" xcopy "%CE_HOME%\\var\\log" %DESTWASDIR%\\%CE_SERVER_NAME%\\var\\log /y /q /s /i /r >nul
if exist "%CE_HOME%\\var\\catalina\\logs" xcopy "%CE_HOME%\\var\\catalina\\logs" %DESTWASDIR%\\%CE_SERVER_NAME%\\var\\catalina\\logs /y /q /s /i /r >nul

goto end:

:REGULARWAS

REM Find all configured App.Servers

echo !!! Find all configured App.Servers ... >> "%CYNCOLLOG%"
chdir /d %CONFIG_CELLS%
set PRODCELLS=%CONFIG_CELLS%
echo PRODCELLS=%PRODCELLS% >> "%CYNCOLLOG%"

if "%GENERAL_DC_VERSION%" EQU "61" goto ver61FileGen:

for /D %%R in (*) do for /D %%N in (%%R/dcInput.txt) do for /F "delims== tokens=1,2" %%J in ('findstr "WS_SERVER_KEY=" "%PRODCELLS%\\%%R\\dcInput.txt"') do for /F "delims=| tokens=1,2" %%L in ("%%K") do for /F "delims=/ tokens=2,4,6" %%X in ("%%M") do echo %%L;%%X;%%Y;%%Z;%%R>"%PROD_HOME%\bin\%%X_%%Y_%%Z.srv"
goto initSrvProcessing:

:ver61FileGen

for /D %%C in (*) do for /D %%N in ("%%C/nodes/"*) do for /D %%S in ("%%C/nodes/%%N/servers/"*) do for /F "delims== tokens=1,2" %%V in ('findstr "WAS_HOME=" "%PRODCELLS%\\%%C\\nodes\\%%N\\servers\\%%S\\dcInputs.txt"') do echo %%W;%%C;%%N;%%S>"%PROD_HOME%\bin\%%C_%%N_%%S.srv"

:initSrvProcessing
chdir /d "%PROD_HOME%\bin"

:serverProcessing
set curSrvFile=

for %%F in (*.srv) do set curSrvFile=%%F

if "%curSrvFile%" == "" goto end:

set validServer=

for %%F in (%curSrvFile%) do for /F "delims=; tokens=1" %%A in (%%F) do set CURWASH=%%A
for %%F in (%curSrvFile%) do for /F "delims=; tokens=2" %%A in (%%F) do set CURCELL=%%A
for %%F in (%curSrvFile%) do for /F "delims=; tokens=3" %%A in (%%F) do set CURNODE=%%A
for %%F in (%curSrvFile%) do for /F "delims=; tokens=4" %%A in (%%F) do set CURSRVR=%%A
for %%F in (%curSrvFile%) do for /F "delims=; tokens=5" %%A in (%%F) do set RUNTIME=%%A

:delsrvfiles

del %CURCELL%_%CURNODE%_%CURSRVR%.srv

if "%WASCOLLECTION%" EQU "-a" goto flagServer
if "%CURSRVR%" NEQ "%filter%" goto serverProcessing:

:flagServer
set SERVER_CORRECT=TRUE
set validServer=true

:ignoreServer
set srvLogs=%DESTWASDIR%\\cells\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\logs
set srvDir=%DESTWASDIR%\\cells\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%
set nodDir=%DESTWASDIR%\\cells\\%CURCELL%\\nodes\\%CURNODE%
set celDir=%DESTWASDIR%\\cells\\%CURCELL%

if %REAL_WAS_COLLECTION%=="" goto was_logging_not_real_on_md:
if defined validServer if not exist %srvLogs% md %srvLogs%
:was_logging_not_real_on_md

set srvXML=%CURWASH%\\config\\cells\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\server.xml

"%JAVA%" -cp "%CLASSPATH%" com.ibm.tivoli.itcam.dc.util.getXMLPiece "%srvXML%" outputStreamRedirect fileName > SysOut.tmp
"%JAVA%" -cp "%CLASSPATH%" com.ibm.tivoli.itcam.dc.util.getXMLPiece "%srvXML%" errorStreamRedirect fileName > SysErr.tmp
"%JAVA%" -cp "%CLASSPATH%" com.ibm.tivoli.itcam.dc.util.getXMLPiece "%srvXML%" ioRedirect stdoutFilename > StdOut.tmp
"%JAVA%" -cp "%CLASSPATH%" com.ibm.tivoli.itcam.dc.util.getXMLPiece "%srvXML%" ioRedirect stderrFilename > StdErr.tmp
"%JAVA%" -cp "%CLASSPATH%" com.ibm.tivoli.itcam.dc.util.getXMLPiece "%srvXML%" environment CCLOG_COMMON_DIR > ComDir.tmp
"%JAVA%" -cp "%CLASSPATH%" com.ibm.tivoli.itcam.dc.util.getXMLPiece "%srvXML%" WASHOME > WasHome.tmp

for /F "delims=;" %%F in (SysOut.tmp) do set SysOut=%%F
for /F "delims=;" %%F in (SysErr.tmp) do set SysErr=%%F
for /F "delims=;" %%F in (StdOut.tmp) do set StdOut=%%F
for /F "delims=;" %%F in (StdErr.tmp) do set StdErr=%%F
for /F "delims=;" %%F in (ComDir.tmp) do set ComDir=%%F
for /F "delims=;" %%F in (WasHome.tmp) do set WasHome=%%F


if "%GENERAL_DC_VERSION%" EQU "71" goto setComDir71:

for /F "delims== tokens=1,2" %%V in ('findstr "RT_WAS_NAME_VER" "%PRODCELLS%\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\dcInputs.txt"') do set WASVER_RT=%%W
for /F "delims== tokens=1,2" %%V in ('findstr "RT_WAS_NODE_NAME" "%PRODCELLS%\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\dcInputs.txt"') do set NODE_RT=%%W
for /F "delims== tokens=1,2" %%V in ('findstr "RT_WAS_SERVER_NAME" "%PRODCELLS%\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\dcInputs.txt"') do set SERVER_RT=%%W

        
echo Version is not 7.1 >> %CYNCOLLOG%
echo PRODCELLS=%PRODCELLS% >> %CYNCOLLOG%
echo CURCELL=%CURCELL% >> %CYNCOLLOG%
echo CURNODE=%CURNODE% >> %CYNCOLLOG%
echo CURSRVR=%CURSRVR% >> %CYNCOLLOG%
echo WASVER_RT=%WASVER_RT% >> %CYNCOLLOG%

set RUNTIME=%WASVER_RT%.%NODE_RT%.%SERVER_RT%
echo RUNTIME=%RUNTIME% >> %CYNCOLLOG%
goto afterSetComDir71

:setComDir71

for /F "delims== tokens=1,2" %%V in ('findstr "RUNTIME_NAME" %PRODCELLS%\%RUNTIME%\dcInput.txt') do set RUNTIME=%%W

:afterSetComDir71

set NewComDir=
REM Get CCLOG_COMMON_DIR out of dc.env.properties

del /f /q *.tmp

if not exist "%PROD_HOME%\\..\\runtime\\%RUNTIME%\\dc.env.properties" goto serverProcessing:

for /F "delims== tokens=1,2" %%V in ('findstr "CCLOG_COMMON_DIR=" "%PROD_HOME%\\..\\runtime\\%RUNTIME%\\dc.env.properties"') do set NewComDir=%%W

if defined NewComDir set ComDir=%NewComDir%

:defineXMLs

set srvXML=%WasHome%\\config\\cells\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\server.xml
set srvVars=%WasHome%\\config\\cells\\%CURCELL%\\nodes\\%CURNODE%\\servers\\%CURSRVR%\\variables.xml
set nodVars=%WasHome%\\config\\cells\\%CURCELL%\\nodes\\%CURNODE%\\variables.xml
set srvIdx=%WasHome%\\config\\cells\\%CURCELL%\\nodes\\%CURNODE%\\serverindex.xml
set celVars=%WasHome%\\config\\cells\\%CURCELL%\\variables.xml

if not defined validServer goto Packing:

if %REAL_WAS_COLLECTION%=="" goto writeDCLogs:

copy %SysOut% %srvLogs% >nul
copy %SysErr% %srvLogs% >nul
copy %StdOut% %srvLogs% >nul
copy %StdErr% %srvLogs% >nul
copy %srvXML% %srvDir% >nul
copy %srvVars% %srvDir% >nul
copy %nodVars% %nodDir% >nul
copy %srvIdx% %nodDir% >nul
copy %celVars% %celDir% >nul

call %WasHome%\bin\versionInfo.bat > %srvDir%\\versionInfo.txt

:writeDCLogs
if not defined SUPPORTED (
    set ComDir=%DEFCOMDIR%
    set CURSRVR=%CE_SERVER_NAME%
    echo "!!! SUPPORTED is not defined" >> %CYNCOLLOG%
)

if not exist "%DESTDCLOGSDIR%\%CURSRVR%" md "%DESTDCLOGSDIR%\%CURSRVR%"

if exist %ComDir%\BWM\logs\%CURNODE%.%CURSRVR% echo "!!! %ComDir%\BWM\logs\%CURNODE%.%CURSRVR% was located." >> "%CYNCOLLOG%"
if exist %ComDir%\BWM\FFDC\%CURNODE%.%CURSRVR% echo "!!! %ComDir%\BWM\FFDC\%CURNODE%.%CURSRVR% was located." >> "%CYNCOLLOG%"
if exist %ComDir%\CYN\logs\%CURNODE%.%CURSRVR% echo "!!! %ComDir%\CYN\logs\%CURNODE%.%CURSRVR% was located." >> "%CYNCOLLOG%"
if exist %ComDir%\CYN\FFDC\%CURNODE%.%CURSRVR% echo "!!! %ComDir%\CYN\FFDC\%CURNODE%.%CURSRVR% was located." >> "%CYNCOLLOG%"

echo "!!! Copying DC logs..." >> "%CYNCOLLOG%"

if exist %ComDir%\BWM\logs\%CURNODE%.%CURSRVR% xcopy "%ComDir%\BWM\logs\%CURNODE%.%CURSRVR%" "%DESTDCLOGSDIR%\%CURSRVR%\BWM\logs" /y /q /s /i /r >nul
if exist %ComDir%\BWM\FFDC\%CURNODE%.%CURSRVR% xcopy "%ComDir%\BWM\FFDC\%CURNODE%.%CURSRVR%" "%DESTDCLOGSDIR%\%CURSRVR%\BWM\FFDC" /y /q /s /i /r >nul
if exist %ComDir%\CYN\logs\%CURNODE%.%CURSRVR% xcopy "%ComDir%\CYN\logs\%CURNODE%.%CURSRVR%" "%DESTDCLOGSDIR%\%CURSRVR%\CYN\logs" /y /q /s /i /r >nul
if exist %ComDir%\CYN\FFDC\%CURNODE%.%CURSRVR% xcopy "%ComDir%\CYN\FFDC\%CURNODE%.%CURSRVR%" "%DESTDCLOGSDIR%\%CURSRVR%\CYN\FFDC" /y /q /s /i /r >nul

if exist %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\BWM\logs (
echo ========================================================== >> "%CYNCOLLOG%"
echo %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\BWM\logs directory >> "%CYNCOLLOG%"
echo ========================================================== >> "%CYNCOLLOG%"
dir %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\BWM\logs >> "%CYNCOLLOG%"
)

if exist %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\BWM\FFDC (
echo ========================================================== >> "%CYNCOLLOG%"
echo %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\BWM\FFDC directory >> "%CYNCOLLOG%"
echo ========================================================== >> "%CYNCOLLOG%"
dir %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\BWM\FFDC >> "%CYNCOLLOG%"
)

if exist %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\CYN\logs (
echo ========================================================== >> "%CYNCOLLOG%"
echo %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\CYN\logs directory >> "%CYNCOLLOG%"
echo ========================================================== >> "%CYNCOLLOG%"
dir %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\CYN\logs >> "%CYNCOLLOG%"
)

if exist %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\CYN\FFDC (
echo ========================================================== >> "%CYNCOLLOG%"
echo %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\CYN\FFDC directory >> "%CYNCOLLOG%"
echo ========================================================== >> "%CYNCOLLOG%"
dir %DESTDCLOGSDIR%\%CURNODE%\%CURSRVR%\CYN\FFDC >> "%CYNCOLLOG%"
)

goto serverProcessing:

REM ********************************************************************************************************
REM ********************************************************************************************************
REM ********************************************************************************************************
REM ********************************************************************************************************
REM ***                                     AD72_Collection
REM ********************************************************************************************************
REM ********************************************************************************************************
REM ********************************************************************************************************
REM ********************************************************************************************************

:collectDCInfo
  ECHO Processing inputs file %1 >> "%CYNCOLLOG%"
  
  set iLibertyHome=""
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "liberty.home=" %1') DO SET iLibertyHome=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_NODE=" %1') DO SET iWASNode=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_SERVER=" %1') DO SET iWASServer=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_CELL=" %1') DO SET iWASCell=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_HOMEPROFILE=" %1') DO SET iWASProfile=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# CONFIG_ROOT=" %1') DO SET iConfigRoot=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# LOG_ROOT=" %1') DO SET iLogRoot=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_VERSION=" %1') DO SET iWASVersion=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_PROFILE=" %1') DO SET iWASProfileName=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_HOMEPROFILE=" %1') DO SET iWASHomeProfileName=%%A

  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_NODE_MODIFIED=" %1') DO SET imWASNode=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_SERVER_MODIFIED=" %1') DO SET imWASServer=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_CELL_MODIFIED=" %1') DO SET imWASCell=%%A
  FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND /I "# WAS_PROFILE_MODIFIED=" %1') DO SET imWASProfileName=%%A

  if "%iWASVersion"=="6" SET iWASVersion="60"
  if "%iWASVersion"=="7" SET iWASVersion="70"
  if "%iWASVersion"=="8" SET iWASVersion="80"
  if "%iLibertyHome%" =="liberty.home" (
      set isLiberty=Y
   ) else (
      set isLiberty=N
	)
	
  SET iAppSrvID=%imWASNode%.%imWASServer%
  SET iDCLogs=%PROD_HOME%\logs\CYN\logs\%iAppSrvID%
  SET iDCFFDC=%PROD_HOME%\logs\CYN\FFDC\%iAppSrvID% 
  SET iDCRuntime=%imWASCell%.%imWASNode%.%imWASServer%.input.properties
  SET iCvariablesXML=%iConfigRoot%\cells\%iWASCell%\variables.xml
  SET iNvariablesXML=%iConfigRoot%\cells\%iWASCell%\nodes\%iWASNode%\variables.xml 
  SET iNServerIndex=%iConfigRoot%\cells\%iWASCell%\nodes\%iWASNode%\serverindex.xml  	 
  SET iSvariablesXML=%iConfigRoot%\cells\%iWASCell%\nodes\%iWASNode%\servers\%iWASServer%\variables.xml
  SET iSServerXML=%iWASHomeProfileName%\servers\%iWASServer%\server.xml

  if "%isLiberty%" EQU "N" SET iDCRuntime=%imWASProfileName%.%imWASCell%.%imWASNode%.%imWASServer%.input.properties
  if "%isLiberty%" EQU "N" SET iSServerXML=%iConfigRoot%\cells\%iWASCell%\nodes\%iWASNode%\servers\%iWASServer%\server.xml
  if "%isLiberty%" EQU "N" ECHO ...iCvariablesXML="%iCvariablesXML%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" ECHO ...iNvariablesXML="%iNvariablesXML%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" ECHO ...iNServerIndex="%iNServerIndex%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "Y" ECHO ...iSvariablesXML="%iSvariablesXML%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "Y" SET iLogRoot=%iWASProfile%\servers\%iWASServer%\logs
 
  ECHO ...iSServerXML=%iSServerXML% >> "%CYNCOLLOG%"
  ECHO ...iWASHomeProfileName=%iWASHomeProfileName% >> "%CYNCOLLOG%"
  ECHO ...iWASVersion=%iWASVersion% >> "%CYNCOLLOG%"
  ECHO ...iWASNode=%iWASNode% >> "%CYNCOLLOG%"
  ECHO ...iWASServer=%iWASServer% >> "%CYNCOLLOG%"
  ECHO ...iWASCell=%iWASCell% >> "%CYNCOLLOG%"
  ECHO ...iWASProfile=%iWASProfile% >> "%CYNCOLLOG%"
  ECHO ...iLogRoot=%iLogRoot% >> "%CYNCOLLOG%" 
  ECHO ...iDCRuntime=%iDCRuntime% >> "%CYNCOLLOG%"
  ECHO ...iAppSrvID=%iAppSrvID% >> "%CYNCOLLOG%"
  ECHO ...iDCLogs=%iDCLogs% >> "%CYNCOLLOG%"
  ECHO ...iDCFFDC=%iDCFFDC% >> "%CYNCOLLOG%"
  ECHO ...imWASNode=%imWASNode% >> "%CYNCOLLOG%"
  ECHO ...imWASServer=%imWASServer% >> "%CYNCOLLOG%"
  ECHO ...imWASCell=%imWASCell% >> "%CYNCOLLOG%"
  ECHO ...imWASProfileName="%imWASProfileName%" >> "%CYNCOLLOG%"

  REM ************************************
  REM ***      Copying DC logs
  REM ************************************

  ECHO Creating collection structure for server %iAppSrvID% >> "%CYNCOLLOG%"
  set serverColDir=%DESTDCDIR%\%iAppSrvID%
  ECHO md %serverColDir% >> "%CYNCOLLOG%"
  md %serverColDir%
  
  ECHO Creating directories for DC's logs >> "%CYNCOLLOG%"
  set serverMainDCLogsDir=%serverColDir%\DCLogs
  set serverDCLogsDir=%serverMainDCLogsDir%\logs
  set serverDCFFDCDir=%serverMainDCLogsDir%\FFDC
   
  ECHO md %serverMainDCLogsDir% >> "%CYNCOLLOG%"
  md %serverMainDCLogsDir%

  ECHO md %serverDCLogsDir% >> "%CYNCOLLOG%"
  md %serverDCLogsDir%

  ECHO md %serverDCFFDCDir% >> "%CYNCOLLOG%"  
  md %serverDCFFDCDir%

  set BATCURDIR=%CD%
  ECHO Checking existence of DC Logs Directory : >> "%CYNCOLLOG%"
  ECHO "%iDCLogs%" >> "%CYNCOLLOG%"
  pushd "%iDCLogs%" 2>NUL && popd
  @if not errorlevel 1  (
    ECHO DC Logs Directory exists... >> "%CYNCOLLOG%" 
    cd "%iDCLogs%"
    ECHO xcopy * "%serverDCLogsDir%" /y /q /s /i /r >> "%CYNCOLLOG%" 
    xcopy * "%serverDCLogsDir%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"
  ) else (
    ECHO Cannot find DC Logs Directory... >> "%CYNCOLLOG%"
	)
  
  ECHO Checking existence of DC FFDC Directory : >> "%CYNCOLLOG%"
  ECHO "%iDCFFDC%" >> "%CYNCOLLOG%"
  pushd "%iDCFFDC%" 2>NUL && popd
  @if not errorlevel 1  ( 
    ECHO DC FFDC Directory exists... >> "%CYNCOLLOG%"
    cd "%iDCFFDC%"
    ECHO xcopy * "%serverDCFFDCDir%" /y /q /s /i /r >> "%CYNCOLLOG%"
    xcopy * "%serverDCFFDCDir%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"
  ) else (
    ECHO Cannot find DC FFDC Directory... >> "%CYNCOLLOG%"
	)
  
  cd %BATCURDIR%
  REM ************************************
  REM ***       Copy runtime
  REM ************************************

  ECHO Creating collection structure for runtime >> "%CYNCOLLOG%"
  set serverRunTime=%serverColDir%\runtime
  ECHO md %serverRunTime% >> "%CYNCOLLOG%"
  md %serverRunTime%

  ECHO xcopy "%iDCRuntime%" "%serverRunTime%" 2>nul >> "%CYNCOLLOG%"
  xcopy "%iDCRuntime%" "%serverRunTime%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"
  
  REM ************************************
  REM ***    Copy WAS information
  REM ************************************
  ECHO Creating collection structure for App.Server information >> "%CYNCOLLOG%"
  set serverWASDir=%serverColDir%\WAS
  ECHO md %serverWASDir% >> "%CYNCOLLOG%"
  md %serverWASDir%
  
  ECHO Creating directories for WAS logs >> "%CYNCOLLOG%"
  set mainWASLogsDir=%serverWASDir%\logs
  ECHO mainWASLogsDir=%serverWASDir%\logs >> "%CYNCOLLOG%"
  

  ECHO Copying server WAS logs... >> "%CYNCOLLOG%"
  ECHO xcopy "%iLogRoot%" "%mainWASLogsDir%" /y /q /s /i /r >> "%CYNCOLLOG%"
  xcopy "%iLogRoot%" "%mainWASLogsDir%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"


  if "%isLiberty%" EQU "N" set cellConfigDir=%serverWASDir%\config\cells\%iWASCell%
  if "%isLiberty%" EQU "N" set nodeConfigDir=%cellConfigDir%\nodes\%iWASNode%
  if "%isLiberty%" EQU "N" set serverConfigDir=%nodeConfigDir%\servers\%iWASServer%
  if "%isLiberty%" EQU "N" ECHO ...cellConfigDir=%cellConfigDir% >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" ECHO ...nodeConfigDir=%nodeConfigDir% >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "Y" set serverConfigDir=%serverWASDir%\servers\%iWASServer%

  ECHO ...serverConfigDir=%serverConfigDir% >> "%CYNCOLLOG%"
  ECHO ...md %serverConfigDir%  >> "%CYNCOLLOG%"
  md %serverConfigDir%

  if "%isLiberty%" EQU "N" ECHO ...copy "%iCvariablesXML% %cellConfigDir%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" copy "%iCvariablesXML%" "%cellConfigDir%" 2>nul >> "%CYNCOLLOG%"																		

  if "%isLiberty%" EQU "N" ECHO ...copy "%iNvariablesXML% %nodeConfigDir%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" copy "%iNvariablesXML%" "%nodeConfigDir%" 2>nul >> "%CYNCOLLOG%"

  if "%isLiberty%" EQU "N" ECHO ...copy "%iNServerIndex% %nodeConfigDir%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" copy "%iNServerIndex%" "%nodeConfigDir%" 2>nul >> "%CYNCOLLOG%"

  if "%isLiberty%" EQU "N" ECHO ...copy "%iSvariablesXML% %serverConfigDir%" >> "%CYNCOLLOG%"
  if "%isLiberty%" EQU "N" copy "%iSvariablesXML%" "%serverConfigDir%" 2>nul >> "%CYNCOLLOG%"

  ECHO ...copy "%iSServerXML% %serverConfigDir%" >> "%CYNCOLLOG%"
  copy "%iSServerXML%" "%serverConfigDir%" >> "%CYNCOLLOG%"
    
  GOTO:EOF
 
 
:checkConnection_Properties

 set iTempDCHome=C:\IBM\ITM\dchome\%VERSION%
 set CONNECTION_PROP_FILE=%iTempDCHome%\runtime\custom\connections.properties
 
 if exist %CONNECTION_PROP_FILE% (
 FOR /F "TOKENS=2,3,4,5,6 DELIMS==" %%A IN ('FIND "connectionstring=" %CONNECTION_PROP_FILE%') do CALL :collectDClessInfo "%%A" "%%B" "%%C" "%%D" "%%E"
)
 
 :collectDClessInfo
SET connection_sting=%1 %2 %3 %4 %5
 
  for /F "TOKENS=1 DELIMS=|" %%a in (%connection_sting%) do set iWASVersion=%%a
  for /F "TOKENS=5 DELIMS=|" %%a in (%connection_sting%) do set iWASNode=%%a
  for /F "TOKENS=7 DELIMS=|" %%a in (%connection_sting%) do set iWASServer=%%a
  for /F "TOKENS=4 DELIMS=|" %%a in (%connection_sting%) do set iWASCell=%%a
  for /F "TOKENS=6 DELIMS=|" %%a in (%connection_sting%) do set iTempWASProfile=%%a
  for /F "TOKENS=11 DELIMS=|" %%a in (%connection_sting%) do set tmpWASHome=%%a

  SET profileRegistry=%tmpWASHome%/properties/profileRegistry.xml
  if Exist "%profileRegistry%" (
  FOR /F delims^=^"^ tokens^=8 %%A IN ('FIND /I "%iTempWASProfile%" "%profileRegistry%"') do set iWASProfile=%%A
)

     ECHO Processing DC-Less configuration >> "%CYNCOLLOG%"
	 
	 set iConfigRoot=%iWASProfile%\config
	 set iLogRoot=%iWASProfile%\logs
	 set iDCRuntime=%iTempDCHome%\runtime\%iTempWASProfile%.%iWASCell%.%iWASNode%.%iWASServer%.dcless.input.properties
	 set iRunTime=

	 FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND "was.nodename=" %iTempDCHome%\jmxdc\etc/jmxdcInputs.txt') do set iTempJMXProfile=%%A
     FOR /F "TOKENS=2 DELIMS==" %%A IN ('FIND "was.servername=" %iTempDCHome%\jmxdc\etc\jmxdcInputs.txt') do set iTempJMXServer=%%A
	 set iAppSrvID=%iTempJMXProfile%.%iTempJMXServer%
	 set iDCLogs=%iTempDCHome%\logs\CYN\logs\%iAppSrvID%
	 set iDCFFDC=%iTempDCHome%\logs\CYN\FFDC\%iAppSrvID%
	 set tempWASCell=%iWASProfile%\config\cells\%iWASCell%
	 set tempWASNode=%tempWASCell%\nodes\%iWASNode%
	 set iCvariablesXML=%tempWASCell%\variables.xml
	 set iNvariablesXML=%tempWASNode%\variables.xml
	 set iNServerIndex=%tempWASNode%\serverindex.xml
	 set iSvariablesXML=%tempWASNode%\servers\%iWASServer%\variables.xml
	 set iSServerXML=%tempWASNode%\servers\%iWASServer%\server.xml

	 
	 
	 ::set server_entry=
     ::set server_check=%iTempWASProfile%.%iWASCell%.%iWASNode%.%iWASServer%.input.properties
     ::FOR /F "TOKENS=2" %%A IN ('FIND /I "%server_check%" "%CYNCOLLOG%"') do set server_entry=%%A
     ::if not server_entry=="" (
     ::echo %server_entry%
     ::echo %iTempWASProfile%.%iWASCell%.%iWASNode%.%iWASServer% has already been collected by the DC collection
    ::GOTO:EOF
    ::)
	 
	echo iWASVersion=%iWASVersion% >> "%CYNCOLLOG%"
	echo iWASNode=%iWASNode% >> "%CYNCOLLOG%"
	echo iWASServer=%iWASServer% >> "%CYNCOLLOG%"
	echo iWASCell=%iWASCell% >> "%CYNCOLLOG%"
	echo iWASProfile=%iWASProfile% >> "%CYNCOLLOG%"
	echo tmpWASHome=%tmpWASHome% >> "%CYNCOLLOG%"
	echo iConfigRoot=%iConfigRoot% >> "%CYNCOLLOG%"
	echo iLogRoot=%iLogRoot% >> "%CYNCOLLOG%"
	echo iDCRuntime=%iDCRuntime% >> "%CYNCOLLOG%"
	echo >> "%CYNCOLLOG%"
	echo iRunTime=%iRunTime% >> "%CYNCOLLOG%"
	echo iAppSrvID=%iAppSrvID% >> "%CYNCOLLOG%"
	echo iDCLogs=%iDCLogs% >> "%CYNCOLLOG%"
	echo iDCFFDC=%iDCFFDC% >> "%CYNCOLLOG%"
	echo	 >> "%CYNCOLLOG%"
	echo iCvariablesXML=%iCvariablesXML% >> "%CYNCOLLOG%"
	echo iNvariablesXML=%iNvariablesXML% >> "%CYNCOLLOG%"
	echo iNServerIndex=%iNServerIndex% >> "%CYNCOLLOG%"
	echo iSvariablesXML=%iSvariablesXML% >> "%CYNCOLLOG%"
	echo iSServerXML=%iSServerXML% >> "%CYNCOLLOG%"
	
	
	REM ************************************
  REM ***      Copying DC logs
  REM ************************************

  ECHO Creating collection structure for server %iAppSrvID% >> "%CYNCOLLOG%"
  set serverColDir=%DESTDCDIR%\%iAppSrvID%
  ECHO md %serverColDir% >> "%CYNCOLLOG%"
  md %serverColDir% 2>nul 
  
  ECHO Creating directories for DC's logs >> "%CYNCOLLOG%"
  set serverMainDCLogsDir=%serverColDir%\DCLogs
  set serverDCLogsDir=%serverMainDCLogsDir%\logs
  set serverDCFFDCDir=%serverMainDCLogsDir%\FFDC
   
  ECHO md %serverMainDCLogsDir% >> "%CYNCOLLOG%"
  md %serverMainDCLogsDir% 2>nul 

  ECHO md %serverDCLogsDir% >> "%CYNCOLLOG%"
  md %serverDCLogsDir% 2>nul 

  ECHO md %serverDCFFDCDir% >> "%CYNCOLLOG%"  
  md %serverDCFFDCDir% 2>nul 

  set BATCURDIR=%CD%
  ECHO Checking existence of DC Logs Directory : >> "%CYNCOLLOG%"
  ECHO "%iDCLogs%" >> "%CYNCOLLOG%"
  pushd "%iDCLogs%" 2>NUL && popd
  @if not errorlevel 1  (
    ECHO DC Logs Directory exists... >> "%CYNCOLLOG%" 
    cd "%iDCLogs%"
    ECHO xcopy * "%serverDCLogsDir%" /y /q /s /i /r >> "%CYNCOLLOG%" 
    xcopy * "%serverDCLogsDir%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"
  ) else (
    ECHO Cannot find DC Logs Directory... >> "%CYNCOLLOG%"
	)
  
  ECHO Checking existence of DC FFDC Directory : >> "%CYNCOLLOG%"
  ECHO "%iDCFFDC%" >> "%CYNCOLLOG%"
  pushd "%iDCFFDC%" 2>NUL && popd
  @if not errorlevel 1  ( 
    ECHO DC FFDC Directory exists... >> "%CYNCOLLOG%"
    cd "%iDCFFDC%"
    ECHO xcopy * "%serverDCFFDCDir%" /y /q /s /i /r >> "%CYNCOLLOG%"
    xcopy * "%serverDCFFDCDir%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"
  ) else (
    ECHO Cannot find DC FFDC Directory... >> "%CYNCOLLOG%"
	)
  
  cd %BATCURDIR%
  REM ************************************
  REM ***       Copy runtime
  REM ************************************

  ECHO Creating collection structure for runtime >> "%CYNCOLLOG%"
  set serverRunTime=%serverColDir%\runtime
  ECHO md %serverRunTime% >> "%CYNCOLLOG%"
  md %serverRunTime% 2>nul 

  ECHO xcopy "%iDCRuntime%" "%serverRunTime%" 2>nul >> "%CYNCOLLOG%"
  xcopy "%iDCRuntime%" "%serverRunTime%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"
  
  REM ************************************
  REM ***    Copy WAS information
  REM ************************************
  ECHO Creating collection structure for App.Server information >> "%CYNCOLLOG%"
  set serverWASDir=%serverColDir%\WAS
  ECHO md %serverWASDir% >> "%CYNCOLLOG%"
  md %serverWASDir% 2>nul 
  
  ECHO Creating directories for WAS logs >> "%CYNCOLLOG%"
  set mainWASLogsDir=%serverWASDir%\logs
  ECHO mainWASLogsDir=%serverWASDir%\logs >> "%CYNCOLLOG%"
  

  ECHO Copying server WAS logs... >> "%CYNCOLLOG%"
  ECHO xcopy "%iLogRoot%" "%mainWASLogsDir%" /y /q /s /i /r >> "%CYNCOLLOG%"
  xcopy "%iLogRoot%" "%mainWASLogsDir%" /y /q /s /i /r 2>nul >> "%CYNCOLLOG%"

  set cellConfigDir=%serverWASDir%\config\cells\%iWASCell%
  set nodeConfigDir=%cellConfigDir%\nodes\%iWASNode%
  set serverConfigDir=%nodeConfigDir%\servers\%iWASServer%
  ECHO ...cellConfigDir=%cellConfigDir% >> "%CYNCOLLOG%"
  ECHO ...nodeConfigDir=%nodeConfigDir% >> "%CYNCOLLOG%"
  
  ECHO ...serverConfigDir=%serverConfigDir% >> "%CYNCOLLOG%"
  ECHO ...md %serverConfigDir%  >> "%CYNCOLLOG%"
  md %serverConfigDir% 2>nul 

  ECHO ...copy "%iCvariablesXML% %cellConfigDir%" >> "%CYNCOLLOG%"
  copy "%iCvariablesXML%" "%cellConfigDir%" 2>nul >> "%CYNCOLLOG%"																		

  ECHO ...copy "%iNvariablesXML% %nodeConfigDir%" >> "%CYNCOLLOG%"
  copy "%iNvariablesXML%" "%nodeConfigDir%" 2>nul >> "%CYNCOLLOG%"

  ECHO ...copy "%iNServerIndex% %nodeConfigDir%" >> "%CYNCOLLOG%"
  copy "%iNServerIndex%" "%nodeConfigDir%" 2>nul >> "%CYNCOLLOG%"

  ECHO ...copy "%iSvariablesXML% %serverConfigDir%" >> "%CYNCOLLOG%"
  copy "%iSvariablesXML%" "%serverConfigDir%" 2>nul >> "%CYNCOLLOG%"

  ECHO ...copy "%iSServerXML% %serverConfigDir%" >> "%CYNCOLLOG%"
  copy "%iSServerXML%" "%serverConfigDir%" 2>nul  >> "%CYNCOLLOG%"
  
    GOTO:EOF
)
 
  
:AD72_Collection
  ECHO Starting AD7.2 Collection >> "%CYNCOLLOG%"

  set JAR="%JAVA_HOME%\bin\java.exe" 
  set JAVA=%JAVA_HOME%\bin\java
  set DESTNAME=%COMPUTERNAME%-CYNenv-%OUTPUT_FILE_SUFFIX%
  set TOOLKIT=%PROD_HOME%\toolkit
  set TMPDIR=%TEMP%
  
  set CLASSPATH=%PROD_HOME%\itcamdc\lib\ext\ppe.probe.jar;.;%TOOLKIT%\lib\bcm-bootstrap.jar;%TOOLKIT%\lib\ext\cdn.jar;%TOOLKIT%\lib\ext\jffdc.jar;%TOOLKIT%\lib\ext\jflt.jar;%TOOLKIT%\lib\ext\jlog.jar;%TOOLKIT%\lib\ext\tk_jflt.jar;%TOOLKIT%\lib\ext\aspectjrt.jar;

  REM *******************************************************************
  REM ***                    Create Structure
  REM *******************************************************************

  ECHO ========================================================== >> %CYNCOLLOG%
  ECHO     Creating Structure... >> %CYNCOLLOG%
  ECHO ========================================================== >> %CYNCOLLOG%

  SET DESTDIR=%TMPDIR%\%DESTNAME%
  SET DESTDCDIR=%DESTDIR%\DC
  SET DESTCFGLOGSDIR=%DESTDCDIR%\config_logs
  SET DESTITCAMDCDIR=%DESTDCDIR%\itcamdc\etc
  SET DESTHOSTDIR=%DESTDIR%\host

  SET DESTGRALDIR=%DESTHOSTDIR%
  SET JARDESTDIR=%DESTDIR%
  
  SET DCLESS_RUNTIME=JMXProfile.jmxdc.ibmjmxdcnode.jmxserver 
 
  ECHO ...DESTDIR=%DESTDIR% >> %CYNCOLLOG%
  ECHO ...DESTDCDIR=%DESTDCDIR% >> %CYNCOLLOG%
  ECHO ...DESTCFGLOGSDIR=%DESTCFGLOGSDIR% >> %CYNCOLLOG%
  ECHO ...DESTITCAMDCDIR=%DESTITCAMDCDIR% >> %CYNCOLLOG%
  ECHO ...DESTHOSTDIR=%DESTHOSTDIR% >> %CYNCOLLOG%
  
  IF EXIST %DESTDIR% rd /s /q %DESTDIR%

  ECHO Creating %DESTCFGLOGSDIR% >> %CYNCOLLOG%
  md %DESTCFGLOGSDIR%

  ECHO Creating %DESTITCAMDCDIR% >> %CYNCOLLOG%
  md %DESTITCAMDCDIR%

  ECHO Creating %DESTHOSTDIR% >> %CYNCOLLOG%
  md %DESTHOSTDIR%

  REM ***************************************************************************  
  REM ***               Copy itcamdc/etc & configuration logs
  REM ***************************************************************************  

  ECHO Collecting basic DC information ...
  ECHO xcopy "%PROD_HOME%\itcamdc\etc" "%DESTITCAMDCDIR%" >> "%CYNCOLLOG%"
  xcopy "%PROD_HOME%\itcamdc\etc" %DESTITCAMDCDIR% /y /q /s /i /r >nul

  ECHO copy "%PROD_HOME%\data" "%DESTCFGLOGSDIR%" >> "%CYNCOLLOG%"
  copy "%PROD_HOME%\data" "%DESTCFGLOGSDIR%" >nul
  
  
  ECHO Looking for existent runtimes >> "%CYNCOLLOG%"
  IF not exist "%PROD_HOME%\\runtime" goto checkParmsForServer
  
  ECHO %PROD_HOME%\runtime exists >> "%CYNCOLLOG%"
  ECHO chdir %PROD_HOME%\runtime >> "%CYNCOLLOG%"
  CD /d "%PROD_HOME%\runtime"

  SET CONFIGURED=
  IF EXIST "%PROD_HOME%\runtime\*.input.properties" SET CONFIGURED=TRUE
  ECHO ... CONFIGURED=%CONFIGURED% >> "%CYNCOLLOG%"
   
  IF "%1" NEQ "" GOTO processRunTimes   
  ECHO User did not select server(s) to be processed
  ECHO User did not select server(s) to be processed >> "%CYNCOLLOG%"
  SET SERVER_CORRECT=TRUE

  GOTO collectGralInfo
  
:processRunTimes
  IF "%1" EQU "-a" GOTO multiSelection  
  ECHO     User selected server %1
  ECHO User selected server %1 >> "%CYNCOLLOG%"

  IF NOT EXIST "%PROD_HOME%\runtime\*.%1.input.properties" GOTO flagUnexistentServer
  SET SERVER_CORRECT=TRUE

  ECHO Collecting DC runtime and App.Server information for the selected server...

  FOR %%A IN (*.%1.input.properties) do if not %%~zA lss 1 CALL :collectDCInfo %%A

  GOTO collectGralInfo
  

:multiSelection
  ECHO     User requested collection for all available servers
  ECHO User requested collection for all available servers >> "%CYNCOLLOG%"
  
  ECHO Collecting DC runtime and App.Server information for the selected servers...
  FOR %%A IN (*.input.properties) do if not %%~zA lss 1 CALL :collectDCInfo %%A
  IF EXIST %DCLESS_RUNTIME% CALL :checkConnection_Properties
  
  SET SERVER_CORRECT=TRUE
  
  GOTO collectGralInfo

  
:checkParmsForServer
  ECHO %PROD_HOME%\\runtime does not exist >> "%CYNCOLLOG%"
  IF "%1" NEQ "" GOTO flagSyntaxError
  ECHO Skipping server related collection >> "%CYNCOLLOG%"
  GOTO collectGralInfo

:flagSyntaxError
  ECHO This Data Collector has never been configured, therefore you
  ECHO can not specify all servers (-a) and/or a single server
  ECHO This Data Collector has never been configured, therefore you >> "%CYNCOLLOG%"
  ECHO can not specify all servers (-a) and/or a single server >> "%CYNCOLLOG%"
  GOTO help 
  
:flagUnexistentServer
  ECHO Server %1 is not configured.
  ECHO Aborting execution...
  ECHO Server %1 is not configured >> "%CYNCOLLOG%"
  ECHO Aborting execution... >> "%CYNCOLLOG%"
  GOTO end
  
  
REM ********************************************************************************************************
REM ********************************************************************************************************
REM ***                                     GENERAL COLLECTION 
REM ********************************************************************************************************
REM ********************************************************************************************************

:collectGralInfo

  ECHO ========================================================== >> %CYNCOLLOG%
  ECHO               Collecting DC information... >> %CYNCOLLOG%
  ECHO ========================================================== >> %CYNCOLLOG%
 

if not defined SERVER_CORRECT echo *** ERROR: App.Server %WASCOLLECTION% not found !!! ***

rem if "%VERSION%" NEQ "@cdc.previous.version@" goto oldStart
if "%VERSION%" NEQ "7.3.0.2.0" goto oldStart
chdir /d "%PROD_HOME%"
goto startCollection

:oldStart
chdir /d "%PROD_HOME%\.."
goto startCollection

:startCollection
echo Collecting General information ...

echo     Collecting environment information ...
dir /s > "%DESTGRALDIR%\dir.info"
set > "%DESTGRALDIR%\env.info"

chdir /d "%PROD_HOME%"

if exist "%SYSTEMROOT%"\system32\systeminfo.exe (
echo     Collecting system information ...
"%SYSTEMROOT%"\system32\systeminfo.exe > "%DESTGRALDIR%\system.info"
)

if exist "%SYSTEMROOT%"\system32\fsutil.exe (
echo     Collecting disk space information ...
echo Space on the system drive %SYSTEMDRIVE% > "%DESTGRALDIR%\disk.info"
"%SYSTEMROOT%"\system32\fsutil.exe volume diskfree %SYSTEMDRIVE% >> "%DESTGRALDIR%\disk.info"
echo. >> %DESTGRALDIR%\disk.info
echo Space on the drive where the product resides: >> %DESTGRALDIR%\disk.info
"%SYSTEMROOT%"\system32\fsutil.exe volume diskfree %PROD_HOME% >> "%DESTGRALDIR%\disk.info"
)

echo     Collecting network information ...
ipconfig /all > "%DESTGRALDIR%\ipconfig.info"
netstat /a /n > "%DESTGRALDIR%\netstat.info"
if exist "%SYSTEMROOT%\system32\netsh.exe" (
netsh diag show all > "%DESTGRALDIR%\netsh.info"
)

echo     Collecting registry information ...
regedit /e "%DESTGRALDIR%\userenv.reg" HKEY_CURRENT_USER\Environment
regedit /e "%DESTGRALDIR%\sysenv.reg" "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\Environment"
regedit /e "%DESTGRALDIR%\candle.reg" HKEY_LOCAL_MACHINE\SOFTWARE\Candle
regedit /e "%DESTGRALDIR%\ibm.reg" HKEY_LOCAL_MACHINE\SOFTWARE\IBM

if exist "%SYSTEMROOT%\system32\eventquery.vbs" (
echo     Collecting errors and warnings from the event log ...
cscript "%SYSTEMROOT%\system32\eventquery.vbs" //nologo /fi "Type eq Error or Type eq Warning" /v > %DESTGRALDIR%\events.info
)

echo     Collecting maintenance levels for all classes ...
"%JAVA%" -cp %CLASSPATH% com.ibm.tivoli.itcam.toolkit.ai.scanner.ClassScanner -classpath %PROD_HOME%\.. >%DESTGRALDIR%\classmaint.log 2>nul

echo     Collecting DB2 log files ...
if exist "%USERPROFILE%\My Documents"\DB2LOG\db2.log copy /y "%USERPROFILE%\My Documents"\DB2LOG\db2.log %DESTGRALDIR%\db2.log >nul

rem if not defined CONFIGURED goto end:

:Packing

if exist "%PROD_HOME%\..\..\config\configured" (
xcopy "%PROD_HOME%\..\..\config" "%DESTDCDIR%\..\config" /y /q /s /i /r >nul
) 

echo Packing collected data ...

rem if "%VERSION%" NEQ "@cdc.previous.version@" (copy "%CYNCOLLOG%" "%DESTGRALDIR%") else copy "%CYNCOLLOG%" "%DESTDIR%" > nul
if "%VERSION%" NEQ "7.3.0.2.0" (copy "%CYNCOLLOG%" "%DESTGRALDIR%") else copy "%CYNCOLLOG%" "%DESTDIR%" > nul

:packageIt
set JARNAME=%JARDESTDIR%.zip

ECHO JAR=%JAR% >> %CYNCOLLOG%
ECHO JARNAME=%JARNAME% >> %CYNCOLLOG%
ECHO TMPDIR=%TMPDIR% >> %CYNCOLLOG%
ECHO DESTNAME=%DESTNAME% >> %CYNCOLLOG%

ECHO executing... >> %CYNCOLLOG%
ECHO   %JAR% sun.tools.jar.Main -cMf %JARNAME% -C %TMPDIR% %DESTNAME% >> %CYNCOLLOG%

%JAR% sun.tools.jar.Main -cMf %JARNAME% -C %TMPDIR% %DESTNAME%

ECHO JARDESTDIR=%JARDESTDIR% >> %CYNCOLLOG%
rd /s /q %JARDESTDIR%

echo.
echo ********************************************************************
echo %JARNAME%
echo This file has been created and contains diagnostic information.
echo Forward this binary file to your IBM Support representative.
echo ********************************************************************
echo.

goto end:

:serverXMLnotFound

goto end:

:invalidServer
    echo Error: Server %WASCOLLECTION% does not exist !!!
goto end:

:help
echo.
echo     %~n0%~x0   Version %VERSION%
echo.
echo Command line syntax(1) is:
echo.
echo    %~n0%~x0
echo.
echo Command line syntax(2) is:
echo.
echo    %~n0%~x0 -a
echo.
echo Command line syntax(3) is:
echo.
echo    %~n0%~x0 server
echo.
echo  where..
echo          a - Collect information from all servers on the box.
echo     server - Name of the only Application Server you want to collect
echo              information from.
echo.
echo     NOTE: If no parameters are specified (syntax 1) no WAS information
echo           will be collected.
echo.
goto end:

:end

